# RandomNumbers.jl
*Random number generators for the Julia language.*

Build Status
[![Build Status](https://github.com/JuliaRandom/RandomNumbers.jl/workflows/CI%20Build/badge.svg?branch=master)](https://github.com/JuliaRandom/RandomNumbers.jl/actions)

Code Coverage:
[![codecov.io](https://codecov.io/github/JuliaRandom/RandomNumbers.jl/coverage.svg?branch=master)](https://codecov.io/github/JuliaRandom/RandomNumbers.jl?branch=master)

Documentation:
[![Stable Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliarandom.github.io/RandomNumbers.jl/stable/)
[![Devel Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliarandom.github.io/RandomNumbers.jl/dev/)

**RandomNumbers.jl** is a package of [Julia](http://julialang.org/), in which several random number generators (RNGs)
are provided.

If you use the Intel Math Kernel Library (MKL), [`VSL.jl`](https://github.com/JuliaRandom/VSL.jl) is also a good
choice for random number generation.

## Installation

This package is registered. The stable version of this package requires Julia `0.7+`. You can install it by:
```julia
(v1.0) pkg> add RandomNumbers
```
It is recommended to run the test suites before using the package:
```julia
(v1.0) pkg> test RandomNumbers
```

## RNG Families

There are four RNG families in this package:

- [PCG](http://juliarandom.github.io/RandomNumbers.jl/stable/man/pcg/):
    A new family of RNG, based on *linear congruential generators*, using a *permuted function* to produce much
    more random output.
- [Mersenne Twister](http://juliarandom.github.io/RandomNumbers.jl/stable/man/mersenne-twisters/):
    The most widely used RNG, with long period.
- [Random123](http://juliarandom.github.io/RandomNumbers.jl/stable/man/random123/):
    A family of good-performance *counter-based* RNG.
- [Xorshift](http://juliarandom.github.io/RandomNumbers.jl/stable/man/xorshifts/):
    A class of RNG based on *exclusive or* and *bit shift*.

Note that `Random123` is now made a separate package as [Random123.jl](https://github.com/JuliaRandom/Random123.jl).
You can still use your old code with `RandomNumbers.Random123` as long as you import `Random123` manually.

## Usage

Please see the [documentation](http://juliarandom.github.io/RandomNumbers.jl/stable/man/basics/) for usage of this package.

## License

This package is under [MIT License](./LICENSE.md).

__precompile__(true)

"""
The module for [Xorshift Family](@ref).

Provide 8 RNG types (others are to be deprecated):

- [`Xoroshiro64Star`](@ref)
- [`Xoroshiro64StarStar`](@ref)
- [`Xoroshiro128Plus`](@ref)
- [`Xoroshiro128StarStar`](@ref)
- [`Xoshiro128Plus`](@ref)
- [`Xoshiro128StarStar`](@ref)
- [`Xoshiro256Plus`](@ref)
- [`Xoshiro256StarStar`](@ref)
"""
module Xorshifts

include("common.jl")

include("splitmix64.jl")

include("xorshift64.jl")

include("xorshift128.jl")

include("xorshift1024.jl")

export Xoroshiro64Star, Xoroshiro64StarStar
include("xoroshiro64.jl")

export Xoroshiro128Plus, Xoroshiro128StarStar
include("xoroshiro128.jl")

export Xoshiro128Plus, Xoshiro128StarStar
include("xoshiro128.jl")

export Xoshiro256Plus, Xoshiro256StarStar
include("xoshiro256.jl")

include("docs.jl")

end

# import Random
import Random: RandomDevice
import RandomNumbers: AbstractRNG

"""
```julia
gen_seed(T[, n])
```

Generate a tuple of `n` truly random numbers in type `T`. If `n` is missing, return only one number.
The "truly" random numbers are provided by the random device of system. See
[`Random.RandomDevice`](https://github.com/JuliaLang/julia/blob/master/base/random.jl#L29).

# Examples
```julia
julia> RandomNumbers.gen_seed(UInt64, 2)  # The output should probably be different on different computers.
(0x26aa3fe5e306f725,0x7b9dc3c227d8acc9)

julia> RandomNumbers.gen_seed(UInt32)
0x9ba60fdc
```
"""
gen_seed(::Type{T}) where {T<:Number} = rand(RandomDevice(), T)
gen_seed(::Type{T}, n) where {T<:Number} = Tuple(rand(RandomDevice(), T, n))

"Get the original output type of a RNG."
@inline output_type(::AbstractRNG{T}) where {T} = T

# For 1.0
# Random.gentype(::Type{T}) where {T<:AbstractRNG} = output_type(T)

"Get the default seed type of a RNG."
@inline seed_type(r::AbstractRNG) = seed_type(typeof(r))

@inline split_uint(x::UInt128, ::Type{UInt64}=UInt64) = (x % UInt64, (x >> 64) % UInt64)
@inline split_uint(x::UInt128, ::Type{UInt32}) = (x % UInt32, (x >> 32) % UInt32,
    (x >> 64) % UInt32, (x >> 96) % UInt32)
@inline split_uint(x::UInt64, ::Type{UInt32}=UInt32) = (x % UInt32, (x >> 32) % UInt32)
@inline union_uint(x::NTuple{2, UInt32}) = unsafe_load(Ptr{UInt64}(pointer(collect(x))), 1)
@inline union_uint(x::NTuple{2, UInt64}) = unsafe_load(Ptr{UInt128}(pointer(collect(x))), 1)
@inline union_uint(x::NTuple{4, UInt32}) = unsafe_load(Ptr{UInt128}(pointer(collect(x))), 1)

@inline function unsafe_copyto!(r1::R, r2::R, ::Type{T}, len) where {R, T}
    arr1 = Ptr{T}(pointer_from_objref(r1))
    arr2 = Ptr{T}(pointer_from_objref(r2))
    for i = 1:len
        unsafe_store!(arr1, unsafe_load(arr2, i), i)
    end
    r1
end

@inline function unsafe_compare(r1::R, r2::R, ::Type{T}, len) where {R, T}
    arr1 = Ptr{T}(pointer_from_objref(r1))
    arr2 = Ptr{T}(pointer_from_objref(r2))
    all(unsafe_load(arr1, i) == unsafe_load(arr2, i) for i in 1:len)
end

using Test

if !@isdefined RandomNumbers
    include("../common.jl")
end

@testset "Xorshifts" begin

    using RandomNumbers.Xorshifts

    @info "Testing Xorshifts"
    stdout_ = stdout
    pwd_ = pwd()
    cd(dirname(@__FILE__))
    rm("./actual"; force=true, recursive=true)
    mkpath("./actual")

    seeds = [0x1ed73cdc948901ab, 0x6d76dcf952161e22, 0x8d0eba5421bc695b, 0xa16065e26c36cce2,
            0x944867a9aacc1bfa, 0x173d478b3ac9de91, 0x97becbc60ac9c1f2, 0x1b1cfeff0505b998,
            0x815a28dc8372d7ab, 0x5c6746d45ae2c5c4, 0x17f22f9aa839c717, 0x1fd7e8194bb9c598,
            0x442ffe4a57ed7987, 0xfd686ec417788eb6, 0x1ec96940807a8749, 0x64d93a8608a988ef]

    for (rng_name, seed_t) in (
            (:SplitMix64,           UInt64),
            (:Xoroshiro64Star,      NTuple{2, UInt32}),
            (:Xoroshiro64StarStar,  NTuple{2, UInt32}),
            (:Xoroshiro128Plus,     NTuple{2, UInt64}),
            (:Xoroshiro128StarStar, NTuple{2, UInt64}),
            (:Xoshiro128Plus,       NTuple{4, UInt32}),
            (:Xoshiro128StarStar,   NTuple{4, UInt32}),
            (:Xoshiro256Plus,       NTuple{4, UInt64}),
            (:Xoshiro256StarStar,   NTuple{4, UInt64}),

            (:Xorshift64,       UInt64),
            (:Xorshift64Star,   UInt64),
            (:Xorshift128,      NTuple{2, UInt64}),
            (:Xorshift128Star,  NTuple{2, UInt64}),
            (:Xorshift128Plus,  NTuple{2, UInt64}),
            (:Xorshift1024,     NTuple{16, UInt64}),
            (:Xorshift1024Star, NTuple{16, UInt64}),
            (:Xorshift1024Plus, NTuple{16, UInt64}),
            (:Xoroshiro128,     NTuple{2, UInt64}),
            (:Xoroshiro128Star, NTuple{2, UInt64}),
        )

        outfile = open(string(
            "./actual/check-$(lowercase("$rng_name")).out"
        ), "w")
        redirect_stdout(outfile)

        rng_type = @eval Xorshifts.$rng_name

        x = rng_type()
        x = rng_type(1234)
        seed!(x, 2345)
        if rng_type == Xorshifts.SplitMix64
            rng_type(0)
        else
            @test_throws(
                ErrorException("0 cannot be the seed"),
                seed!(x, seed_t <: Tuple ? (zeros(seed_t.types[1], length(seed_t.types))...,) : 0)
            )
        end
        seed!(x)
        @test seed_type(x) == seed_t
        @test copyto!(copy(x), x) == x

        seed = seed_t <: Tuple ? ((seeds[i] % seed_t.types[i] for i in 1:length(seed_t.types))...,) : seeds[1] % seed_t
        x = rng_type(seed)

        for i in 1:100
            @printf "%.9f\n" rand(x)
        end

        close(outfile)
    end
    redirect_stdout(stdout_)


    compare_dirs("expected", "actual")
    
    # Package content should not be modified.
    # rm("./actual"; force=true, recursive=true)

    cd(pwd_)

end

import Base: copy, copyto!, ==
import RandomNumbers: AbstractRNG, seed_type

"""
```julia
WrappedRNG{R, T1, T2} <: AbstractRNG{T2}
WrappedRNG(base_rng, T2)
WrappedRNG(R, T2, args...)
```

Wrap a RNG which originally provides output in T1 into a RNG that provides output in T2.

# Examples
```jldoctest
julia> r = Xorshifts.Xorshift128Star(123);

julia> RandomNumbers.output_type(r)
UInt64

julia> r1 = WrappedRNG(r, UInt32);

julia> RandomNumbers.output_type(r1)
UInt32

julia> r2 = WrappedRNG(Xorshifts.Xorshift128Star, UInt32, 123);

julia> RandomNumbers.output_type(r2)
UInt32

julia> @Test.test rand(r1, UInt32, 3) == rand(r2, UInt32, 3)
Test Passed
```
"""
mutable struct WrappedRNG{R<:AbstractRNG, T1<:BitTypes, T2<:BitTypes} <: AbstractRNG{T2}
    base_rng::R
    x::T1
    p::Int
    WrappedRNG{R, T1, T2}() where {R <: AbstractRNG, T1 <: BitTypes, T2 <: BitTypes} = 
        (@assert T1 ≠ T2; new())
end

function WrappedRNG(base_rng::AbstractRNG{T1}, ::Type{T2}) where {T1 <: BitTypes, T2 <: BitTypes}
    wr = WrappedRNG{typeof(base_rng), T1, T2}()
    wr.base_rng = copy(base_rng)
    if sizeof(T1) > sizeof(T2)
        wr.x = rand(wr.base_rng, T1)
    end
    wr.p = 0
    wr
end

function WrappedRNG(::Type{R}, ::Type{T2}, args...) where {R <: AbstractRNG, T2 <: BitTypes}
    base_rng = R(args...)
    WrappedRNG(base_rng, T2)
end

WrappedRNG(base_rng::WrappedRNG{R, T1, T2}, ::Type{T3}) where 
    {R <: AbstractRNG, T1 <: BitTypes, T2 <: BitTypes, T3 <: BitTypes} = WrappedRNG(base_rng.base_rng, T3)

seed_type(::Type{WrappedRNG{R, T1, T2}}) where {R, T1, T2} = seed_type(R)

function copyto!(dest::R, src::R) where R <: WrappedRNG
    copyto!(dest.base_rng, src.base_rng)
    dest.x = src.x
    dest.p = src.p
    dest
end

function copy(src::R) where R <: WrappedRNG
    wr = R()
    wr.base_rng = copy(src.base_rng)
    wr.x = src.x
    wr.p = src.p
    wr
end

==(r1::R, r2::R) where R <: WrappedRNG = r1.base_rng == r2.base_rng && r1.x == r2.x && r1.p == r2.p

function seed!(wr::WrappedRNG, seed...)
    seed!(wr.base_rng, seed...)
        if sizeof(T1) > sizeof(T2)
            wr.x = rand(wr.base_rng, T1)
        end
    wr.p = 0
    wr
end

@inline function rand(rng::WrappedRNG{R, T1, T2}, ::Type{T2}) where
        {R <: AbstractRNG, T1 <: BitTypes, T2 <: BitTypes}
    s1 = sizeof(T1)
    s2 = sizeof(T2)
    if s2 >= s1
        t = rand(rng.base_rng, T1) % T2
        for i in 2:(s2 ÷ s1)
            t |= (rand(rng.base_rng, T1) % T2) << ((s1 << 3) * (i - 1))
        end
    else
        t = rng.x % T2
        rng.p += 1
        if rng.p == s1 ÷ s2
            rng.p = 0
            rng.x = rand(rng.base_rng, T1)
        else
            rng.x >>= s2 << 3
        end
    end
    return t
end

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: gen_seed, seed_type

@inline rand(r::MT19937, ::Type{UInt32}) = mt_get(r)

seed!(r::MT19937, seed::Integer) = mt_set!(r, seed % UInt32)
seed!(r::MT19937, seed::NTuple{N, UInt32}=gen_seed(UInt32, N)) = mt_set!(r, seed)

seed_type(::Type{MT19937}) = NTuple{N, UInt32}

function copyto!(dest::MT19937, src::MT19937)
    copyto!(dest.mt, src.mt)
    dest.mti = src.mti
    dest
end

copy(src::MT19937) = MT19937(copy(src.mt), src.mti)

==(r1::MT19937, r2::MT19937) = r1.mt == r2.mt && r1.mti == r2.mti

"Do one iteration and get the current value of a Xorshift RNG object."
xorshift_next

let doc_xorshift64(r) = """
```julia
$r <: AbstractXorshift64
$r([seed])
```

$r RNG. The `seed` can be an `UInt64`,
or an `Integer` which will be initialized with `SplitMix64`.
"""
    @doc doc_xorshift64("Xorshift64") Xorshift64
    @doc doc_xorshift64("Xorshift64Star") Xorshift64Star
end
@deprecate Xorshift64 Xoshiro256StarStar
@deprecate Xorshift64Star Xoshiro256StarStar

let doc_xorshift128(r) = """
```julia
$r <: AbstractXorshift128
$r([seed])
```

$r RNG. The `seed` can be a `Tuple` of two `UInt64`s,
or an `Integer` which will be initialized with `SplitMix64`.
"""
    @doc doc_xorshift128("Xorshift128") Xorshift128
    @doc doc_xorshift128("Xorshift128Star") Xorshift128Star
    @doc doc_xorshift128("Xorshift128Plus") Xorshift128Plus
end
@deprecate Xorshift128 Xoshiro256StarStar
@deprecate Xorshift128Star Xoshiro256StarStar
@deprecate Xorshift128Plus Xoshiro256StarStar

let doc_xorshift1024(r) = """
```julia
$r <: AbstractXorshift1024
$r([seed...])
```

$r RNG. The `seed` can be a `Tuple` of 16 `UInt64`s,
or an `Integer` which will be initialized with `SplitMix64`.
"""
    @doc doc_xorshift1024("Xorshift1024") Xorshift1024
    @doc doc_xorshift1024("Xorshift1024Star") Xorshift1024Star
    @doc doc_xorshift1024("Xorshift1024Plus") Xorshift1024Plus
end
@deprecate Xorshift1024 Xoshiro256StarStar
@deprecate Xorshift1024Star Xoshiro256StarStar
@deprecate Xorshift1024Plus Xoshiro256StarStar
# TODO: implement Xoroshiro1024Star / Xoroshiro1024StarStar and Xoroshiro512StarStar / Xoroshiro512Plus

let doc_xoroshiro64(r) = """
```julia
$r <: AbstractXoroshiro64
$r([seed])
```

$r RNG. The `seed` can be a `Tuple` of two `UInt32`s,
or an `Integer` which will be initialized with `SplitMix64`.
"""
    @doc doc_xoroshiro64("Xoroshiro64Star") Xoroshiro64Star
    @doc doc_xoroshiro64("Xoroshiro64StarStar") Xoroshiro64StarStar
end


let doc_xoroshiro128(r) = """
```julia
$r <: AbstractXoroshiro128
$r([seed])
```

$r RNG. The `seed` can be a `Tuple` of two `UInt64`s,
or an `Integer` which will be initialized with `SplitMix64`.
"""
    @doc doc_xoroshiro128("Xoroshiro128") Xoroshiro128
    @doc doc_xoroshiro128("Xoroshiro128Star") Xoroshiro128Star
    @doc doc_xoroshiro128("Xoroshiro128Plus") Xoroshiro128Plus
    @doc doc_xoroshiro128("Xoroshiro128StarStar") Xoroshiro128StarStar
end
@deprecate Xoroshiro128 Xoroshiro128Plus
@deprecate Xoroshiro128Star Xoroshiro128StarStar


let doc_xoshiro128(r) = """
```julia
$r <: AbstractXoshiro128
$r([seed])
```

$r RNG. The `seed` can be a `Tuple` of four `UInt32`s, a `Tuple` of two,
or an `Integer` which will be initialized with `SplitMix64`.
"""
    @doc doc_xoshiro128("Xoshiro128Plus") Xoshiro128Plus
    @doc doc_xoshiro128("Xoshiro128StarStar") Xoshiro128StarStar
end


let doc_xoshiro256(r) = """
```julia
$r <: AbstractXoshiro256
$r([seed])
```

$r RNG. The `seed` can be a `Tuple` of four `UInt64`s, or an `Integer` which will be automatically convert to
an `UInt64` number (and then is initialized with SplitMix64). Zero seeds are not acceptable.
"""
    @doc doc_xoshiro256("Xoshiro256Plus") Xoshiro256Plus
    @doc doc_xoshiro256("Xoshiro256StarStar") Xoshiro256StarStar
end

using Test
@testset "RandomNumbers" begin
    for (i, testfile) in enumerate((
        "generic.jl",
        "wrapped_rng.jl",
        "randfloat.jl",
        "PCG/runtests.jl",
        "MersenneTwisters/runtests.jl",
        "Xorshifts/runtests.jl"))
        @eval module $(Symbol("T$i"))
            include("common.jl")
            include($testfile)
        end
    end
end

using RandomNumbers
using Test

@testset "Check types" begin
    @test typeof(randfloat()) == Float64
    @test typeof(randfloat(Float32)) == Float32
    @test typeof(randfloat(Float64)) == Float64
    @test typeof(randfloat(Float16)) == Float16
    
    # arrays
    @test typeof(randfloat(Float16,2)) <: Vector{Float16}
    @test typeof(randfloat(Float32,2)) <: Vector{Float32}
    @test typeof(randfloat(Float64,2)) <: Vector{Float64}

    @test typeof(randfloat(Float16,2,3)) <: Matrix{Float16}
    @test typeof(randfloat(Float32,2,3)) <: Matrix{Float32}
    @test typeof(randfloat(Float64,2,3)) <: Matrix{Float64}
end

@testset "Non-default RNG" begin
    import RandomNumbers.Xorshifts.Xorshift64
    rng = Xorshift64()
    @test typeof(randfloat(rng)) == Float64
    @test typeof(randfloat(rng,Float16)) == Float16
    @test typeof(randfloat(rng,Float32)) == Float32
    @test typeof(randfloat(rng,Float64)) == Float64
    
    # arrays
    @test typeof(randfloat(rng,Float16,2)) <: Vector{Float16}
    @test typeof(randfloat(rng,Float32,2)) <: Vector{Float32}
    @test typeof(randfloat(rng,Float64,2)) <: Vector{Float64}

    @test typeof(randfloat(rng,Float16,2,3)) <: Matrix{Float16}
    @test typeof(randfloat(rng,Float32,2,3)) <: Matrix{Float32}
    @test typeof(randfloat(rng,Float64,2,3)) <: Matrix{Float64}

    import RandomNumbers.MersenneTwisters.MT19937
    rng = MT19937()
    @test typeof(randfloat(rng)) == Float64
    @test typeof(randfloat(rng,Float16)) == Float16
    @test typeof(randfloat(rng,Float32)) == Float32
    @test typeof(randfloat(rng,Float64)) == Float64
    
    # arrays
    @test typeof(randfloat(rng,Float16,2)) <: Vector{Float16}
    @test typeof(randfloat(rng,Float32,2)) <: Vector{Float32}
    @test typeof(randfloat(rng,Float64,2)) <: Vector{Float64}

    @test typeof(randfloat(rng,Float16,2,3)) <: Matrix{Float16}
    @test typeof(randfloat(rng,Float32,2,3)) <: Matrix{Float32}
    @test typeof(randfloat(rng,Float64,2,3)) <: Matrix{Float64}
end

@testset "Distribution is uniform [0,1) Float64" begin
    N = 100_000_000

    x = randfloat(N)
    @test maximum(x) > 0.999999
    @test minimum(x) < 1e-7

    exponent_mask = 0x7ff0000000000000
    exponent_bias = 1023

    # histogram for exponents
    H = fill(0,64)  
    for xi in x     # 0.5 is in H[1], 0.25 is in H[2] etc
        e = reinterpret(UInt64,xi) & exponent_mask
        H[exponent_bias-Int(e >> 52)] += 1
    end

    # test that the most frequent exponents occur at 50%, 25%, 12.5% etc.
    for i in 1:10   
        @test isapprox(H[i]/N,2.0^-i,atol=5e-4)
    end
end

@testset "Distribution is uniform [0,1) Float32" begin
    N = 100_000_000

    x = randfloat(Float32,N)
    @test maximum(x) > prevfloat(1f0,5)
    @test minimum(x) < 1e-7

    exponent_mask = 0x7f800000
    exponent_bias = 127

    # histogram for exponents
    H = fill(0,64)  
    for xi in x     # 0.5f0 is in H[1], 0.25f0 is in H[2] etc
        e = reinterpret(UInt32,xi) & exponent_mask
        H[exponent_bias-Int(e >> 23)] += 1
    end

    # test that the most frequent exponents occur at 50%, 25%, 12.5% etc.
    for i in 1:10   
        @test isapprox(H[i]/N,2.0^-i,atol=5e-4)
    end
end

@testset "Distribution is uniform [0,1) Float16" begin
    N = 100_000_000

    x = randfloat(Float16,N)
    @test maximum(x) == prevfloat(one(Float16))
    @test minimum(x) == zero(Float16)               # zero can be produced

    exponent_mask = 0x7c00
    exponent_bias = 15

    # histogram for exponents
    H = fill(0,16)  
    for xi in x     # 0.5f0 is in H[1], 0.25f0 is in H[2] etc
        e = reinterpret(UInt16,xi) & exponent_mask
        H[exponent_bias-Int(e >> 10)] += 1
    end

    # test that the most frequent exponents occur at 50%, 25%, 12.5% etc.
    for i in 1:10   
        @test isapprox(H[i]/N,2.0^-i,atol=5e-4)
    end
end

__precompile__(true)

"""
The module for [Mersenne Twisters](@ref).

Currently only provide one RNG type:

- [`MT19937`](@ref)
"""
module MersenneTwisters

export MT19937

include("bases.jl")
include("main.jl")

end

using RandomNumbers.MersenneTwisters
import Random123
using RandomNumbers.Random123
using RandomNumbers.PCG
using RandomNumbers.Xorshifts
import Random: rand
import Printf: @printf, @sprintf

include("common.jl")

function rank_timing_results(results)
    sort!(results, by = last)
    mtidx = findfirst(t -> endswith(t[1], "MersenneTwister"), results)
    timemt = results[mtidx][2]
    println("\n\nRanked:")
    for i in 1:length(results)
        rngstr, timetaken = results[i]
        @printf "%4d. %s: %6.3f ns/64 bits" i rngstr timetaken
        p = 100.0 * (timetaken-timemt)/timemt
        c = (p < 0.0 ? :green : (p > 0.0 ? :red : :normal))
        if p != 0.0
            signstr = (p > 0.0 ? "+" : "")
            printstyled("  ", signstr, @sprintf("%.2f%%", p); color=c)
        end
        println("")
    end
end

macro rngtest(rngs...)
    results = []
    for rng in rngs
        if rng.head == :call
            r = @eval $rng
            name = rng.args[1]
        else
            r = @eval $(rng.args[1])
            name = rng.args[2]
        end
        timetaken = speed_test(r)
        @printf "%20s: %6.3f ns/64 bits\n" name timetaken
        push!(results, (@sprintf("%20s", name), timetaken))
    end
    rank_timing_results(results)
end

@rngtest(
Xorshift64(123),
Xorshift64Star(123),
Xorshift128Star(123),
Xorshift128Plus(123),
Xorshift1024Star(123),
Xorshift1024Plus(123),
Xoroshiro128Plus(123),
Xoroshiro128Star(123),

MersenneTwister(123),
MT19937(123),

(Threefry2x(UInt64, (123, 321)), Threefry2x64),
(Threefry4x(UInt64, (123, 321, 456, 654)), Threefry4x64),
(Threefry2x(UInt32, (123, 321)), Threefry2x32),
(Threefry4x(UInt32, (123, 321, 456, 654)), Threefry4x32),
(Philox2x(UInt64, 123), Philox2x64),
(Philox4x(UInt64, (123, 321)), Philox4x64),
(Philox2x(UInt32, 123), Philox2x32),
(Philox4x(UInt32, (123, 321)), Philox4x32),
(AESNI1x(123), AESNI1x128),
(ARS1x(123), ARS1x128),
(AESNI4x((123, 321, 456, 654)), AESNI4x32),
(ARS4x((123, 321, 456, 654)), ARS4x32),

(PCGStateOneseq(UInt64, PCG_XSH_RS, 123), PCG_XSH_RS_128),
(PCGStateOneseq(UInt64, PCG_XSH_RR, 123), PCG_XSH_RR_128),
(PCGStateOneseq(UInt64, PCG_RXS_M_XS, 123), PCG_RXS_M_XS_64),
(PCGStateOneseq(UInt64, PCG_XSL_RR, 123), PCG_XSL_RR_128),
(PCGStateOneseq(UInt64, PCG_XSL_RR_RR, 123), PCG_XSL_RR_RR_64),

(PCGStateOneseq(UInt32, PCG_XSH_RS, 123), PCG_XSH_RS_64),
(PCGStateOneseq(UInt32, PCG_XSH_RR, 123), PCG_XSH_RR_64),
(PCGStateOneseq(UInt32, PCG_RXS_M_XS, 123), PCG_RXS_M_XS_32),
(PCGStateOneseq(UInt32, PCG_XSL_RR, 123), PCG_XSL_RR_64),

(PCGStateOneseq(UInt128, PCG_RXS_M_XS, 123), PCG_RXS_M_XS_128),
(PCGStateOneseq(UInt128, PCG_XSL_RR_RR, 123), PCG_XSL_RR_RR_128),
)

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: AbstractRNG, gen_seed, split_uint, seed_type

"""
```julia
AbstractXorshift128 <: AbstractRNG{UInt64}
```

The base abstract type for `Xorshift128`, `Xorshift128Star` and `Xorshift128Plus`.
"""
abstract type AbstractXorshift128 <: AbstractRNG{UInt64} end

for (star, plus) in (
        (false, false),
        (false, true),
        (true, false),
    )
    rng_name = Symbol(string("Xorshift128", star ? "Star" : plus ? "Plus" : ""))
    @eval begin
        mutable struct $rng_name <: AbstractXorshift128
            x::UInt64
            y::UInt64
        end

        function $rng_name(seed::NTuple{2, UInt64}=gen_seed(UInt64, 2))
            r = $rng_name(zero(UInt64), zero(UInt64))
            seed!(r, seed)
            r
        end

        $rng_name(seed::Integer) = $rng_name(init_seed(seed, UInt64, 2))

        @inline function xorshift_next(r::$rng_name)
            t = r.x ⊻ r.x << 23
            r.x = r.y
            r.y = t ⊻ (t >> 3) ⊻ r.y ⊻ (r.y >> 24)
            $(star ? :(r.y * 2685821657736338717) :
              plus ? :(r.y + r.x) : :(r.y))
        end
    end
end

@inline seed_type(::Type{T}) where T <: AbstractXorshift128 = NTuple{2, UInt64}

function copyto!(dest::T, src::T) where T <: AbstractXorshift128
    dest.x = src.x
    dest.y = src.y
    dest
end

copy(src::T) where T <: AbstractXorshift128 = copyto!(T(), src)

==(r1::T, r2::T) where T <: AbstractXorshift128 = r1.x == r2.x && r1.y == r2.y

seed!(r::AbstractXorshift128, seed::Integer) = seed!(r, split_uint(seed % UInt128))

function seed!(r::AbstractXorshift128, seed::NTuple{2, UInt64}=gen_seed(UInt64, 2))
    all(==(0), seed) && error("0 cannot be the seed")
    r.x = seed[1]
    r.y = seed[2]
    xorshift_next(r)
    xorshift_next(r)
    r
end

@inline rand(r::AbstractXorshift128, ::Type{UInt64}) = xorshift_next(r)

__precompile__(true)

"The module for [PCG Family](@ref)."
module PCG

# PCG
export PCGStateMCG, PCGStateOneseq, PCGStateUnique, PCGStateSetseq

# PCG Methods
export PCG_XSH_RS, PCG_XSH_RR, PCG_RXS_M_XS, PCG_XSL_RR, PCG_XSL_RR_RR

export PCGUInt, PCGMethod, PCG_LIST

export bounded_rand, advance!

const pcg_uints = (UInt8, UInt16, UInt32, UInt64, UInt128)
const PCGUInt = Union{pcg_uints...}

"""
One of PCG output method: high xorshift, followed by a random shift.

Fast.
"""
const PCG_XSH_RS = Val{:XSH_RS}
"""
One of PCG output method: high xorshift, followed by a random rotate.

Fast. Slightly better statistically than `PCG_XSH_RS`.
"""
const PCG_XSH_RR = Val{:XSH_RR}
"""
One of PCG output method: random xorshift, mcg multiply, fixed xorshift.

The most statistically powerful generator, but slower than some of the others.
"""
const PCG_RXS_M_XS = Val{:RXS_M_XS}
"""
One of PCG output method: fixed xorshift (to low bits), random rotate.

Useful for 128-bit types that are split across two CPU registers.
"""
const PCG_XSL_RR = Val{:XSL_RR}
"""
One of PCG output method: fixed xorshift (to low bits), random rotate (both parts).

Useful for 128-bit types that are split across two CPU registers. Use this in need of an invertable 128-bit
RNG.
"""
const PCG_XSL_RR_RR = Val{:XSL_RR_RR}

const pcg_methods = (PCG_XSH_RS, PCG_XSH_RR, PCG_RXS_M_XS, PCG_XSL_RR, PCG_XSL_RR_RR)

"""
The `Union` of all the PCG method types: `PCG_XSH_RS`, `PCG_XSH_RR`, `PCG_RXS_M_XS`, `PCG_XSL_RR`, and `PCG_XSL_RR_RR`.
"""
const PCGMethod = Union{pcg_methods...}

include("pcg_list.jl")

include("bases.jl")

include("main.jl")

end

try
    using RNGTest
catch
    @warn "No RNGTest package found. Only speed benchmarks can be run."
end
using RandomNumbers
import Printf: @printf
using Random

function bigcrush(rng::RandomNumbers.AbstractRNG{T}) where {T<:Number}
    p = RNGTest.wrap(r, T)
    RNGTest.bigcrushTestU01(p)
end

function speed_test(rng::RandomNumbers.AbstractRNG{T}, n=100_000_000) where {T<:Number}
    A = Array{T}(undef, n)
    rand!(rng, A)
    elapsed = @elapsed rand!(rng, A)
    elapsed * 1e9 / n * 8 / sizeof(T)
end

function bigcrush(rng::MersenneTwister)
    p = RNGTest.wrap(r, UInt64)
    RNGTest.bigcrushTestU01(p)
end

function speed_test(rng::MersenneTwister, n=100_000_000)
    T = UInt64
    A = Array{T}(undef, n)
    rand!(rng, A)
    elapsed = @elapsed rand!(rng, A)
    elapsed * 1e9 / n * 8 / sizeof(T)
end

function test_all(rng::Random.AbstractRNG, n=100_000_000)
    fo = open("$TEST_NAME.log", "w")
    redirect_stdout(fo)
    println(TEST_NAME)
    speed = speed_test(rng, n)
    @printf "Speed Test: %.3f ns/64 bits\n" speed
    flush(fo)
    bigcrush(rng)
    close(fo)
end

const PCG_LIST = (
    (:Oneseq, UInt16, :XSH_RS, UInt8),
    (:Oneseq, UInt32, :XSH_RS, UInt16),
    (:Oneseq, UInt64, :XSH_RS, UInt32),
    (:Oneseq, UInt128, :XSH_RS, UInt64),
    (:Unique, UInt16, :XSH_RS, UInt8),
    (:Unique, UInt32, :XSH_RS, UInt16),
    (:Unique, UInt64, :XSH_RS, UInt32),
    (:Unique, UInt128, :XSH_RS, UInt64),
    (:Setseq, UInt16, :XSH_RS, UInt8),
    (:Setseq, UInt32, :XSH_RS, UInt16),
    (:Setseq, UInt64, :XSH_RS, UInt32),
    (:Setseq, UInt128, :XSH_RS, UInt64),
    (:MCG, UInt16, :XSH_RS, UInt8),
    (:MCG, UInt32, :XSH_RS, UInt16),
    (:MCG, UInt64, :XSH_RS, UInt32),
    (:MCG, UInt128, :XSH_RS, UInt64),

    (:Oneseq, UInt16, :XSH_RR, UInt8),
    (:Oneseq, UInt32, :XSH_RR, UInt16),
    (:Oneseq, UInt64, :XSH_RR, UInt32),
    (:Oneseq, UInt128, :XSH_RR, UInt64),
    (:Unique, UInt16, :XSH_RR, UInt8),
    (:Unique, UInt32, :XSH_RR, UInt16),
    (:Unique, UInt64, :XSH_RR, UInt32),
    (:Unique, UInt128, :XSH_RR, UInt64),
    (:Setseq, UInt16, :XSH_RR, UInt8),
    (:Setseq, UInt32, :XSH_RR, UInt16),
    (:Setseq, UInt64, :XSH_RR, UInt32),
    (:Setseq, UInt128, :XSH_RR, UInt64),
    (:MCG, UInt16, :XSH_RR, UInt8),
    (:MCG, UInt32, :XSH_RR, UInt16),
    (:MCG, UInt64, :XSH_RR, UInt32),
    (:MCG, UInt128, :XSH_RR, UInt64),

    (:Oneseq, UInt8, :RXS_M_XS, UInt8),
    (:Oneseq, UInt16, :RXS_M_XS, UInt16),
    (:Oneseq, UInt32, :RXS_M_XS, UInt32),
    (:Oneseq, UInt64, :RXS_M_XS, UInt64),
    (:Oneseq, UInt128, :RXS_M_XS, UInt128),
    (:Unique, UInt16, :RXS_M_XS, UInt16),
    (:Unique, UInt32, :RXS_M_XS, UInt32),
    (:Unique, UInt64, :RXS_M_XS, UInt64),
    (:Unique, UInt128, :RXS_M_XS, UInt128),
    (:Setseq, UInt8, :RXS_M_XS, UInt8),
    (:Setseq, UInt16, :RXS_M_XS, UInt16),
    (:Setseq, UInt32, :RXS_M_XS, UInt32),
    (:Setseq, UInt64, :RXS_M_XS, UInt64),
    (:Setseq, UInt128, :RXS_M_XS, UInt128),

    (:Oneseq, UInt64, :XSL_RR, UInt32),
    (:Oneseq, UInt128, :XSL_RR, UInt64),
    (:Unique, UInt64, :XSL_RR, UInt32),
    (:Unique, UInt128, :XSL_RR, UInt64),
    (:Setseq, UInt64, :XSL_RR, UInt32),
    (:Setseq, UInt128, :XSL_RR, UInt64),
    (:MCG, UInt64, :XSL_RR, UInt32),
    (:MCG, UInt128, :XSL_RR, UInt64),

    (:Oneseq, UInt64, :XSL_RR_RR, UInt64),
    (:Oneseq, UInt128, :XSL_RR_RR, UInt128),
    (:Unique, UInt64, :XSL_RR_RR, UInt64),
    (:Unique, UInt128, :XSL_RR_RR, UInt128),
    (:Setseq, UInt64, :XSL_RR_RR, UInt64),
    (:Setseq, UInt128, :XSL_RR_RR, UInt128)
)

let p() = begin
        s = "The list of all the parameter combinations that can be used for PCG.\n\n"
        s *= "|Stream variation|State Type|Method Type|Output Type|\n"
        s *= "|---|---|---|---|\n"
        for (pcg_type, uint_type, method, output_type) in PCG_LIST
            s *= "|`PCGState$pcg_type`|`$uint_type`|`PCG_$method`|`$output_type`|\n"
        end
        s
    end
    @doc p() PCG_LIST
end

using RandomNumbers
import Random: seed!
using Test: @test, @test_throws
using Printf: @printf

function compare_dirs(dir1::AbstractString, dir2::AbstractString)
    files1 = readdir(dir1)
    files2 = readdir(dir2)
    @test files1 == files2

    for file in files1
        file1 = joinpath(dir1, file)
        file2 = joinpath(dir2, file)
        lines1 = readlines(file1)
        lines2 = readlines(file2)
        @test lines1 == lines2
    end
end

strip_cr(line::String) = replace(line, r"\r\n$" => "\n")

import RandomNumbers: AbstractRNG, gen_seed

"""
```julia
MersenneTwister{T} <: AbstractRNG{T}
```

The base type of Mersenne Twisters.
"""
abstract type MersenneTwister{T<:Number} <: AbstractRNG{T} end

const N = 624
const M = 397
const UPPER_MASK = 0x80000000
const LOWER_MASK = 0x7fffffff

"""
```julia
MT19937 <: MersenneTwister{UInt32}
MT19937([seed])
```

MT19937 RNG. The `seed` is a `Tuple` of $N `UInt32` numbers, or an `Integer` which will be automatically
convert to an `UInt32` number.
"""
mutable struct MT19937 <: MersenneTwister{UInt32}
    mt::Vector{UInt32}
    mti::Int
    function MT19937(x::Vector{UInt32}, i::Int) 
        @assert length(x) == N
        new(x, i)
    end
end
MT19937(seed::Integer) = seed!(MT19937(Vector{UInt32}(undef, N), 1), seed % UInt32)
MT19937(seed::NTuple{N, UInt32}=gen_seed(UInt32, N)) = seed!(MT19937(Vector{UInt32}(undef, N), 1), seed)

"Set up a `MT19937` RNG object using a `Tuple` of $N `UInt32` numbers."
@inline function mt_set!(r::MT19937, s::NTuple{N, UInt32})
    @inbounds for i in 1:N
        r.mt[i] = s[i]
    end
    r.mti = N + 1
    r
end

"Set up a `MT19937` RNG object using an `UInt32` number."
@inline function mt_set!(r::MT19937, s::UInt32)
    r.mt[1] = s
    @inbounds for i in 2:N
        r.mt[i] = 0x6c078965 * (r.mt[i-1] ⊻ (r.mt[i-1] >> 30)) + (i - 1) % UInt32
    end
    r.mti = N + 1
    r
end

@inline mt_magic(y) = ((y % Int32) << 31 >> 31) & 0x9908b0df
"Get a random `UInt32` number from a `MT19937` object."
@inline function mt_get(r::MT19937)
    mt = r.mt
    if r.mti > N
        @inbounds for i in 1:N-M
            y = (mt[i] & UPPER_MASK) | (mt[i+1] & LOWER_MASK)
            mt[i] = mt[i + M] ⊻ (y >> 1) ⊻ mt_magic(y)
        end
        @inbounds for i in N-M+1:N-1
            y = (mt[i] & UPPER_MASK) | (mt[i+1] & LOWER_MASK)
            mt[i] = mt[i + M - N] ⊻ (y >> 1) ⊻ mt_magic(y)
        end
        @inbounds begin
            y = (mt[N] & UPPER_MASK) | (mt[1] & LOWER_MASK)
            mt[N] = mt[M] ⊻ (y >> 1) ⊻ mt_magic(y)
        end
        r.mti = 1
    end
    k = mt[r.mti]
    k ⊻= (k >> 11)
    k ⊻= (k << 7) & 0x9d2c5680
    k ⊻= (k << 15) & 0xefc60000
    k ⊻= (k >> 18)

    r.mti += 1
    k
end

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: AbstractRNG, gen_seed, split_uint, seed_type

"""
```julia
AbstractXoroshiro64 <: AbstractRNG{UInt32}
```

The base abstract type for `Xoroshiro64Star` and `Xoroshiro64StarStar`.
"""
abstract type AbstractXoroshiro64 <: AbstractRNG{UInt32} end

for (star, starstar) in (
        (true, false),
        (false, true),
    )
    rng_name = Symbol(string("Xoroshiro64", star ? "Star" : starstar ? "StarStar" : ""))
    @eval begin
        mutable struct $rng_name <: AbstractXoroshiro64
            x::UInt32
            y::UInt32
        end

        function $rng_name(seed::NTuple{2, UInt32}=gen_seed(UInt32, 2))
            r = $rng_name(zero(UInt32), zero(UInt32))
            seed!(r, seed)
            r
        end

        $rng_name(seed::Integer) = $rng_name(init_seed(seed, UInt32, 2))

        @inline function xorshift_next(r::$rng_name)
            p = r.x * 0x9E3779BB
            $(starstar ? :(p = xorshift_rotl(p, 5) * (5 % UInt32)) : nothing)
            s1 = r.y ⊻ r.x
            r.x = xorshift_rotl(r.x, 26) ⊻ s1 ⊻ (s1 << 9)
            r.y = xorshift_rotl(s1, 13)
            p
        end
    end
end

@inline seed_type(::Type{T}) where T <: AbstractXoroshiro64 = NTuple{2, UInt32}

function copyto!(dest::T, src::T) where T <: AbstractXoroshiro64
    dest.x = src.x
    dest.y = src.y
    dest
end

copy(src::T) where T <: AbstractXoroshiro64 = copyto!(T(), src)

==(r1::T, r2::T) where T <: AbstractXoroshiro64 = r1.x == r2.x && r1.y == r2.y

seed!(r::AbstractXoroshiro64, seed::Integer) = seed!(r, split_uint(seed % UInt64))
function seed!(r::AbstractXoroshiro64, seed::NTuple{2, UInt32}=gen_seed(UInt32, 2))
    all(==(0), seed) && error("0 cannot be the seed")
    r.x = seed[1]
    r.y = seed[2]
    xorshift_next(r)
    xorshift_next(r)
    r
end

@inline rand(r::AbstractXoroshiro64, ::Type{UInt32}) = xorshift_next(r)

using Test

@testset "WrappedRNG" begin
    using RandomNumbers.Xorshifts

    @info "Testing WrappedRNG"
    seed = RandomNumbers.gen_seed(UInt64, 2)
    r = Xoroshiro128(seed)

    r1 = WrappedRNG(r, UInt32)
    r2 = WrappedRNG(Xoroshiro128, UInt32, seed)

    @test rand(r1, UInt64) == rand(r2, UInt64)

    r3 = WrappedRNG(r2, UInt128)

    rand(r2, UInt64)

    @test rand(r3, UInt128) == rand(r2, UInt128)

    @test copyto!(copy(r1), r1) == r1
end

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: gen_seed, seed_type

# Generic functions

@inline seed!(r::AbstractPCG{StateType}, seed::Integer=gen_seed(StateType)) where
    StateType <: PCGUInt = pcg_seed!(r, seed % StateType)
@inline seed!(r::PCGStateSetseq{StateType}, seed::NTuple{2, Integer}=gen_seed(StateType, 2)) where
    StateType <: PCGUInt = pcg_seed!(r, seed[1] % StateType, seed[2] % StateType)

@inline seed_type(::Type{PCGStateOneseq{T, T1, T2}}) where {T, T1, T2} = T
@inline seed_type(::Type{PCGStateMCG{   T, T1, T2}}) where {T, T1, T2} = T
@inline seed_type(::Type{PCGStateUnique{T, T1, T2}}) where {T, T1, T2} = T
@inline seed_type(::Type{PCGStateSetseq{T, T1, T2}}) where {T, T1, T2} = NTuple{2, T}

function copyto!(dest::T, src::T) where T <: AbstractPCG
    dest.state = src.state
    dest
end
function copyto!(dest::T, src::T) where T <: PCGStateSetseq
    dest.state = src.state
    dest.inc = src.inc
    dest
end

copy(src::T) where T <: AbstractPCG = copyto!(T(), src)

==(r1::T, r2::T) where T <: AbstractPCG = r1.state == r2.state
==(r1::T, r2::T) where T <: PCGStateSetseq = r1.state == r2.state && r1.inc == r2.inc


@inline function rand(r::AbstractPCG{StateType, MethodType, OutputType}, ::Type{OutputType}) where
        {StateType <: Union{pcg_uints[1:end-1]...}, MethodType <: PCGMethod, OutputType <: PCGUInt}
    old_state = r.state
    pcg_step!(r)
    pcg_output(old_state, MethodType)
end

@inline function rand(r::AbstractPCG{UInt128, MethodType, OutputType}, ::Type{OutputType}) where
        {MethodType <: PCGMethod, OutputType <: PCGUInt}
    pcg_step!(r)
    pcg_output(r.state, MethodType)
end

"""
```julia
bounded_rand(r, bound)
```

Producing a random number less than a given `bound` in the output type.
"""
@inline function bounded_rand(s::AbstractPCG{StateType, MethodType, OutputType}, bound::OutputType) where
        {StateType <: PCGUInt, MethodType <: PCGMethod, OutputType <: PCGUInt}
    threshold = (-bound) % bound
    r = rand(s, OutputType)
    while r < threshold
        r = rand(s, OutputType)
    end
    r % bound
end

"""
```julia
advance!(r, Δ)
```

Advance a PCG object `r` for `Δ` steps.

# Examples
```jldoctest
julia> r = PCGStateSetseq(UInt64, PCG_RXS_M_XS, (123, 321))
PCGStateSetseq{UInt64,Val{:RXS_M_XS},UInt64}(0x45389f8b27528b29, 0x0000000000000283)

julia> A = rand(r, UInt64, 2);

julia> p = rand(r);

julia> r
PCGStateSetseq{UInt64,Val{:RXS_M_XS},UInt64}(0x9b1fc763ae0ad702, 0x0000000000000283)

julia> advance!(r, -3)
PCGStateSetseq{UInt64,Val{:RXS_M_XS},UInt64}(0x45389f8b27528b29, 0x0000000000000283)

julia> @Test.test A == rand(r, UInt64, 2)
Test Passed

julia> @Test.test p == rand(r)
Test Passed
```
"""
@inline function advance!(r::AbstractPCG{StateType}, Δ::Integer) where StateType <: PCGUInt
    pcg_advance!(r, Δ % StateType)
    r
end

# Constructors.
for (pcg_type_t, uint_type, method_symbol, output_type) in PCG_LIST
    pcg_type = Symbol("PCGState$pcg_type_t")
    method = Val{method_symbol}

    if pcg_type_t != :Setseq
        @eval function $pcg_type(output_type::Type{$output_type}, method::Type{$method},
                seed::Integer=gen_seed($uint_type))
            s = $pcg_type{$uint_type, method, output_type}()
            seed!(s, seed)
            s
        end
    else
        @eval function $pcg_type(output_type::Type{$output_type}, method::Type{$method},
                seed::NTuple{2, Integer}=gen_seed($uint_type, 2))
            s = $pcg_type{$uint_type, method, output_type}()
            seed!(s, seed)
            s
        end
    end
end

"""
```julia
PCGStateOneseq{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
    AbstractPCG{StateType, MethodType, OutputType}
PCGStateOneseq([seed])
PCGStateOneseq(output_type[, seed])
PCGStateOneseq(method[, seed])
PCGStateOneseq(output_type[, method, seed])
```

PCG generator with *single streams*, where all instances use the same fixed constant, thus the RNG always
somewhere in same sequence.

`seed` is an `Integer` which will be automatically converted to the state type.

`output_type` is the type of the PCG's output. If missing it is set to `UInt64`.

`method` is one of the [`PCGMethod`](@ref). If missing it is set to `PCG_XSH_RS`.

See [`PCG_LIST`](@ref) for the available parameter combinations.
"""
PCGStateOneseq(seed::Integer=gen_seed(UInt128)) = PCGStateOneseq(UInt64, PCG_XSH_RS, seed)
PCGStateOneseq(::Type{T}, seed::Integer=gen_seed(UInt128)) where
    T <: PCGUInt = PCGStateOneseq(T, PCG_XSH_RS, seed)
PCGStateOneseq(::Type{T}, seed::Integer=gen_seed(UInt128)) where
    T <: PCGMethod = PCGStateOneseq(UInt64, T, seed)

"""
```julia
PCGStateMCG{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
    AbstractPCG{StateType, MethodType, OutputType}
PCGStateMCG([seed])
PCGStateMCG(output_type[, seed])
PCGStateMCG(method[, seed])
PCGStateMCG(output_type[, method, seed])
```

PCG generator with *MCG*, where the increment is zero, resulting in a single stream and reduced period.

`seed` is an `Integer` which will be automatically converted to the state type.

`output_type` is the type of the PCG's output. If missing it is set to `UInt64`.

`method` is one of the [`PCGMethod`](@ref). If missing it is set to `PCG_XSH_RS`.

See [`PCG_LIST`](@ref) for the available parameter combinations.
"""
PCGStateMCG(seed::Integer=gen_seed(UInt128)) = PCGStateMCG(UInt64, PCG_XSH_RS, seed)
PCGStateMCG(::Type{T}, seed::Integer=gen_seed(UInt128)) where
    T <: PCGUInt = PCGStateMCG(T, PCG_XSH_RS, seed)
PCGStateMCG(::Type{T}, seed::Integer=gen_seed(UInt128)) where
    T <: PCGMethod = PCGStateMCG(UInt64, T, seed)

"""
```julia
PCGStateSetseq{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
    AbstractPCG{StateType, MethodType, OutputType}
PCGStateSetseq([seed])
PCGStateSetseq(output_type[, seed])
PCGStateSetseq(method[, seed])
PCGStateSetseq(output_type[, method, seed])
```

PCG generator with *specific streams*, where the constant can be changed at any time, selecting a different
random sequence.

`seed` is a `Tuple` of two `Integer`s which will both be automatically converted to the state type.

`output_type` is the type of the PCG's output. If missing it is set to `UInt64`.

`method` is one of the [`PCGMethod`](@ref). If missing it is set to `PCG_XSH_RS`.

See [`PCG_LIST`](@ref) for the available parameter combinations.
"""
PCGStateSetseq(seed::NTuple{2, Integer}=gen_seed(UInt128, 2)) = PCGStateSetseq(UInt64, PCG_XSH_RS, seed)
PCGStateSetseq(::Type{T}, seed::NTuple{2, Integer}=gen_seed(UInt128, 2)) where
    T <: PCGUInt = PCGStateSetseq(T, PCG_XSH_RS, seed)
PCGStateSetseq(::Type{T}, seed::NTuple{2, Integer}=gen_seed(UInt128, 2)) where
    T <: PCGMethod = PCGStateSetseq(UInt64, T, seed)

"""
```julia
PCGStateUnique{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
    AbstractPCG{StateType, MethodType, OutputType}
PCGStateUnique([seed])
PCGStateUnique(output_type[, seed])
PCGStateUnique(method[, seed])
PCGStateUnique(output_type[, method, seed])
```

PCG generator with *unique streams*, where the constant is based on the memory address of the object, thus
every RNG has its own unique sequence.

`seed` is an `Integer` which will be automatically converted to the state type.

`output_type` is the type of the PCG's output. If missing it is set to `UInt64`.

`method` is one of the [`PCGMethod`](@ref). If missing it is set to `PCG_XSH_RS`.

See [`PCG_LIST`](@ref) for the available parameter combinations.
"""
PCGStateUnique(seed::Integer=gen_seed(UInt128)) = PCGStateUnique(UInt64, PCG_XSH_RS, seed)
PCGStateUnique(::Type{T}, seed::Integer=gen_seed(UInt128)) where
    T <: PCGUInt = PCGStateUnique(T, PCG_XSH_RS, seed)
PCGStateUnique(::Type{T}, seed::Integer=gen_seed(UInt128)) where
    T <: PCGMethod = PCGStateUnique(UInt64, T, seed)

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: AbstractRNG, gen_seed, seed_type, unsafe_copyto!, unsafe_compare

"""
```julia
AbstractXorshift1024 <: AbstractRNG{UInt64}
```

The base abstract type for `Xorshift1024`, `Xorshift1024Star` and `Xorshift1024Plus`.
"""
abstract type AbstractXorshift1024 <: AbstractRNG{UInt64} end

for (star, plus) in (
        (false, false),
        (false, true),
        (true, false),
    )
    rng_name = Symbol(string("Xorshift1024", star ? "Star" : plus ? "Plus" : ""))
    @eval begin
        mutable struct $rng_name <: AbstractXorshift1024
            s0::UInt64
            s1::UInt64
            s2::UInt64
            s3::UInt64
            s4::UInt64
            s5::UInt64
            s6::UInt64
            s7::UInt64
            s8::UInt64
            s9::UInt64
            s10::UInt64
            s11::UInt64
            s12::UInt64
            s13::UInt64
            s14::UInt64
            s15::UInt64
            p::Int
        end

        function $rng_name(seed::NTuple{16, UInt64}=gen_seed(UInt64, 16))
            o = zero(UInt64)
            r = $rng_name(
                o, o, o, o, o, o, o, o,
                o, o, o, o, o, o, o, o,
                zero(Int)
            )
            seed!(r, seed)
            r
        end

        function $rng_name(seed::Integer)
            $rng_name(init_seed(seed, UInt64, 16))
        end

        @inline function xorshift_next(r::$rng_name)
            ptr = Ptr{UInt64}(pointer_from_objref(r))
            p = r.p
            s0 = unsafe_load(ptr, p + 1)
            p = (p + 1) % 16
            s1 = unsafe_load(ptr, p + 1)
            s1 ⊻= s1 << 31
            s1 ⊻= s1 >> 11
            s1 ⊻= s0 >> 30
            s1 ⊻= s0
            unsafe_store!(ptr, s1, p + 1)
            r.p = p
            $(star ? :(s1 * 2685821657736338717) :
              plus ? :(s1 + s0) : :s1)
        end
    end
end

@inline seed_type(::Type{T}) where T <: AbstractXorshift1024 = NTuple{16, UInt64}

function copyto!(dest::T, src::T) where T <: AbstractXorshift1024
    unsafe_copyto!(dest, src, UInt64, 16)
    dest.p = src.p
    dest
end

copy(src::T) where T <: AbstractXorshift1024 = copyto!(T(), src)

==(r1::T, r2::T) where T <: AbstractXorshift1024 = unsafe_compare(r1, r2, UInt64, 16) && r1.p == r2.p

function seed!(r::AbstractXorshift1024, seed::NTuple{16, UInt64})
    all(==(0), seed) && error("0 cannot be the seed")
    ptr = Ptr{UInt64}(pointer_from_objref(r))
    @inbounds for i in 1:16
        unsafe_store!(ptr, seed[i], i)
    end
    r.p = 0
    for i in 1:16
        xorshift_next(r)
    end
    r
end

function seed!(r::AbstractXorshift1024, seed::Integer...)
    l = length(seed)
    @assert 0 ≤ l ≤ 16 
    if l == 0
        return seed!(r, gen_seed(UInt64, 16))
    end
    seed = [x % UInt64 for x in seed]
    while length(seed) < 16
        push!(seed, splitmix64(seed[end]))
    end
    seed!(r, Tuple(seed))
end

@inline rand(r::AbstractXorshift1024, ::Type{UInt64}) = xorshift_next(r)

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: AbstractRNG, gen_seed, seed_type

"""
```julia
AbstractXorshift64 <: AbstractRNG{UInt64}
```

The base abstract type for `Xorshift64` and `Xorshift64Star`.
"""
abstract type AbstractXorshift64 <: AbstractRNG{UInt64} end

for star in (false, true)
    rng_name = Symbol(string("Xorshift64", star ? "Star" : ""))
    @eval begin
        mutable struct $rng_name <: AbstractXorshift64
            x::UInt64
        end

        function $rng_name(seed::Integer=gen_seed(UInt64))
            r = $rng_name(zero(UInt64))
            seed = init_seed(seed, UInt64)
            seed!(r, seed)
            r
        end

        @inline function xorshift_next(r::$rng_name)
            r.x ⊻= r.x << 18
            r.x ⊻= r.x >> 31
            r.x ⊻= r.x << 11
            $(star ? :(r.x * 2685821657736338717) : :(r.x))
        end
    end
end

@inline seed_type(::Type{T}) where T <: AbstractXorshift64 = UInt64

function copyto!(dest::T, src::T) where T <: AbstractXorshift64
    dest.x = src.x
    dest
end

copy(src::T) where T <: AbstractXorshift64 = copyto!(T(), src)

==(r1::T, r2::T) where T <: AbstractXorshift64 = r1.x == r2.x

function seed!(r::AbstractXorshift64, seed::Integer=gen_seed(UInt64))
    seed == 0 && error("0 cannot be the seed")
    r.x = seed % UInt64
    xorshift_next(r)
    r
end

@inline rand(r::AbstractXorshift64, ::Type{UInt64}) = xorshift_next(r)

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: AbstractRNG, gen_seed, split_uint, seed_type

"""
```julia
AbstractXoshiro128 <: AbstractRNG{UInt32}
```

The base abstract type for `Xoshiro128Plus` and `Xoshiro128StarStar`.
"""
abstract type AbstractXoshiro128 <: AbstractRNG{UInt32} end

for (plus, starstar) in (
        (true, false),
        (false, true),
    )
    rng_name = Symbol(string("Xoshiro128", plus ? "Plus" : starstar ? "StarStar" : ""))
    @eval begin
        mutable struct $rng_name <: AbstractXoshiro128
            x::UInt32
            y::UInt32
            z::UInt32
            w::UInt32
        end

        function $rng_name(seed::NTuple{4, UInt32}=gen_seed(UInt32, 4))
            o = zero(UInt32)
            r = $rng_name(o, o, o, o)
            seed!(r, seed)
            r
        end

        $rng_name(seed::Integer) = $rng_name(init_seed(seed, UInt32, 4))

        @inline function xorshift_next(r::$rng_name)
            p = $(plus ? :(r.x + r.w)
                : starstar ? :(xorshift_rotl(r.x * (5 % UInt32), 7) * (9 % UInt32)) : nothing)
            t = r.y << 9
            r.z ⊻= r.x
            r.w ⊻= r.y
            r.y ⊻= r.z
            r.x ⊻= r.w
            r.z ⊻= t
            r.w = xorshift_rotl(r.w, 11)
            p
        end
    end
end

@inline seed_type(::Type{T}) where T <: AbstractXoshiro128 = NTuple{4, UInt32}

function copyto!(dest::T, src::T) where T <: AbstractXoshiro128
    dest.x = src.x
    dest.y = src.y
    dest.z = src.z
    dest.w = src.w
    dest
end

copy(src::T) where T <: AbstractXoshiro128 = copyto!(T(), src)

==(r1::T, r2::T) where T <: AbstractXoshiro128 = r1.x == r2.x && r1.y == r2.y && r1.z == r2.z && r1.w == r2.w

seed!(r::AbstractXoshiro128, seed::Integer) = seed!(r, split_uint(seed % UInt128, UInt32))
function seed!(r::AbstractXoshiro128, seed::NTuple{4, UInt32}=gen_seed(UInt32, 4))
    all(==(0), seed) && error("0 cannot be the seed")
    r.x = seed[1]
    r.y = seed[2]
    r.z = seed[3]
    r.w = seed[4]
    xorshift_next(r)
    xorshift_next(r)
    xorshift_next(r)
    xorshift_next(r)
    r
end

@inline rand(r::AbstractXoshiro128, ::Type{UInt32}) = xorshift_next(r)

import Random
import Random: rand, UInt52, rng_native_52

"""
```julia
AbstractRNG{T} <: Random.AbstractRNG
```

The abstract type of Random Number Generators. T indicates the original output type of a RNG.
"""
abstract type AbstractRNG{T<:Number} <: Random.AbstractRNG end

const BitTypes = Union{Bool, UInt8, UInt16, UInt32, UInt64, UInt128, Int8, Int16, Int32, Int64, Int128}

# For compatibility with functions in Random stdlib.
rng_native_52(::AbstractRNG) = UInt64
rand(rng::AbstractRNG, ::Random.SamplerType{T}) where {T<:BitTypes} = rand(rng, T)

# see https://github.com/JuliaRandom/RandomNumbers.jl/issues/8
# TODO: find a better approach.
@inline function rand(rng::AbstractRNG{T}, ::Type{Float64}=Float64) where {T<:Union{UInt64, UInt128}}
    reinterpret(Float64, Base.exponent_one(Float64) | rand(rng, UInt52())) - 1.0
end
@inline function rand(rng::AbstractRNG{T}, ::Type{Float64}=Float64) where {T<:Union{UInt8, UInt16, UInt32}}
    rand(rng, T) * exp2(-sizeof(T) << 3)
end

@inline function rand(rng::AbstractRNG{T1}, ::Type{T2}) where {T1<:BitTypes, T2<:BitTypes}
    s1 = sizeof(T1)
    s2 = sizeof(T2)
    t = rand(rng, T1) % T2
    s1 > s2 && return t
    for i in 2:(s2 ÷ s1)
        t |= (rand(rng, T1) % T2) << ((s1 << 3) * (i - 1))
    end
    t
end

# This file contains the basic functions of PCG.
import RandomNumbers: AbstractRNG

"Return the default multiplier for a certain type."
@inline default_multiplier(::Type{UInt8}) = 0x8d
@inline default_multiplier(::Type{UInt16}) = 0x321d
@inline default_multiplier(::Type{UInt32}) = 0x2c9277b5
@inline default_multiplier(::Type{UInt64}) = 0x5851f42d4c957f2d
@inline default_multiplier(::Type{UInt128}) = 0x2360ed051fc65da44385df649fccf645

"Return the default increment for a certain type."
@inline default_increment(::Type{UInt8}) = 0x4d
@inline default_increment(::Type{UInt16}) = 0xbb75
@inline default_increment(::Type{UInt32}) = 0xac564b05
@inline default_increment(::Type{UInt64}) = 0x14057b7ef767814f
@inline default_increment(::Type{UInt128}) = 0x5851f42d4c957f2d14057b7ef767814f

"Return the default MCG multiplier for a certain type."
@inline mcg_multiplier(::Type{UInt8}) = 0xd9
@inline mcg_multiplier(::Type{UInt16}) = 0xf2d9
@inline mcg_multiplier(::Type{UInt32}) = 0x108ef2d9
@inline mcg_multiplier(::Type{UInt64}) = 0xaef17502108ef2d9
@inline mcg_multiplier(::Type{UInt128}) = 0xf69019274d7f699caef17502108ef2d9

"Return the default MCG unmultiplier for a certain type."
@inline mcg_unmultiplier(::Type{UInt8}) = 0x69
@inline mcg_unmultiplier(::Type{UInt16}) = 0x6d69
@inline mcg_unmultiplier(::Type{UInt32}) = 0xacb86d69
@inline mcg_unmultiplier(::Type{UInt64}) = 0xd04ca582acb86d69
@inline mcg_unmultiplier(::Type{UInt128}) = 0xc827645e182bc965d04ca582acb86d69

@inline uint_index(::Type{UInt8}) = 1
@inline uint_index(::Type{UInt16}) = 2
@inline uint_index(::Type{UInt32}) = 3
@inline uint_index(::Type{UInt64}) = 4
@inline uint_index(::Type{UInt128}) = 5

@inline half_width(::Type{UInt16}) = UInt8
@inline half_width(::Type{UInt32}) = UInt16
@inline half_width(::Type{UInt64}) = UInt32
@inline half_width(::Type{UInt128}) = UInt64


# Shift and Rotate functions

# Rotate functions.
@inline function pcg_rotr(value::T, rot::T) where T <: PCGUInt
    s = sizeof(T) << 3
    (value >> (rot % s)) | (value << (-rot % s))
end


"General advance functions."
@inline function pcg_advance_lcg(state::T, delta::T, cur_mult::T, cur_plus::T) where T <: PCGUInt
    acc_mult = 1 % T
    acc_plus = 0 % T
    while delta > 0
        if delta & 1 == 1
            acc_mult *= cur_mult
            acc_plus = acc_plus * cur_mult + cur_plus
        end
        cur_plus = (cur_mult + (1 % T)) * cur_plus
        cur_mult *= cur_mult
        delta = delta >> 1
    end
    acc_mult * state + acc_plus
end


# output_xsh_rs
# Xorshift High, Random Shift.
# return half bits of T.
@inline function pcg_output(state::T, ::Type{PCG_XSH_RS}) where T <: Union{pcg_uints[2:end]...}
    return_bits = sizeof(T) << 2
    bits = return_bits << 1
    spare_bits = bits - return_bits
    op_bits = spare_bits - 5 >= 64 ? 5 :
              spare_bits - 4 >= 32 ? 4 :
              spare_bits - 3 >= 16 ? 3 :
              spare_bits - 2 >= 4  ? 2 :
              spare_bits - 1 >= 1  ? 1 : 0
    mask = (1 << op_bits) - 1
    xshift = op_bits + (return_bits + mask) >> 1
    rshift = op_bits != 0 ? (state >> (bits - op_bits)) & mask : 0 % T
    state = state ⊻ (state >> xshift)
    (state >> (spare_bits - op_bits - mask + rshift)) % half_width(T)
end

# output_xsh_rr
# Xorshift High, Random Rotation.
# return half bits of T.
@inline function pcg_output(state::T, ::Type{PCG_XSH_RR}) where T <: Union{pcg_uints[2:end]...}
    return_bits = sizeof(T) << 2
    bits = return_bits << 1
    spare_bits = bits - return_bits
    op_bits = return_bits >= 128 ? 7 :
              return_bits >=  64 ? 6 :
              return_bits >=  32 ? 5 :
              return_bits >=  16 ? 4 : 3
    mask = (1 << op_bits) - 1
    xshift = (op_bits + return_bits) >> 1
    rot = (state >> (bits - op_bits)) & mask
    state ⊻= (state >> xshift)
    result = (state >> (spare_bits - op_bits)) % half_width(T)
    pcg_rotr(result, rot % half_width(T))
end

# output_rxs_m_xs
# Random Xorshift, Multiplication, Xorshift.
# return the same bits as T.
# Insecure.
@inline function pcg_output(state::T, ::Type{PCG_RXS_M_XS}) where T <: PCGUInt
    bits = return_bits = sizeof(T) << 3
    op_bits = return_bits >= 128 ? 6 :
              return_bits >=  64 ? 5 :
              return_bits >=  32 ? 4 :
              return_bits >=  16 ? 3 : 2
    mask = (1 << op_bits) - 1
    rshift = (state >> (bits - op_bits)) & mask
    state ⊻= state >> (op_bits + rshift)
    state *= mcg_multiplier(T)
    state ⊻ (state >> ((return_bits << 1 + 2) ÷ 3))
end

# output_xsl_rr
# Xorshift Low, Random Rotation.
# return half bits of T.
@inline function pcg_output(state::T, ::Type{PCG_XSL_RR}) where T <: Union{UInt64, UInt128}
    return_bits = sizeof(T) << 2
    bits = return_bits << 1
    spare_bits = bits - return_bits
    op_bits = return_bits >= 128 ? 7 :
              return_bits >=  64 ? 6 :
              return_bits >=  32 ? 5 :
              return_bits >=  16 ? 4 : 3
    mask = (1 << op_bits) - 1
    xshift = (spare_bits + return_bits) >> 1
    rot = (state >> (bits - op_bits)) & mask
    pcg_rotr((state ⊻ (state >> xshift)) % half_width(T), rot % half_width(T))
end

# output_xsl_rr_rr
# Xorshift Low, Random Rotation, Random Rotation.
# return the same bits as T.
# Insecure.
@inline function pcg_output(state::T, ::Type{PCG_XSL_RR_RR}) where T <: Union{UInt64, UInt128}
    half_bits = sizeof(T) << 2
    bits = half_bits << 1
    spare_bits = bits - half_bits
    op_bits = half_bits >= 128 ? 7 :
              half_bits >=  64 ? 6 :
              half_bits >=  32 ? 5 :
              half_bits >=  16 ? 4 : 3
    mask = (1 << op_bits) - 1
    xshift = (spare_bits + half_bits) >> 1
    rot = (state >> (bits - op_bits)) & mask
    state ⊻= state >> xshift
    low_bits = state % half_width(T)
    low_bits = pcg_rotr(low_bits, rot % half_width(T))
    high_bits = (state >> spare_bits) % half_width(T)
    rot2 = low_bits & mask
    high_bits = pcg_rotr(high_bits, rot2 % half_width(T))
    ((high_bits % T) << spare_bits) ⊻ (low_bits % T)
end

# PCGState types, SRandom and Step functions.
"""
```julia
AbstractPCG{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <: AbstractRNG{OutputType}
```

The base abstract type for PCGs.
"""
abstract type AbstractPCG{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt
                         } <: AbstractRNG{OutputType} end

# pcg_state_XX
# XX is one of the UInt types.
mutable struct PCGStateOneseq{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
        AbstractPCG{StateType, MethodType, OutputType}
    state::StateType
    PCGStateOneseq{StateType, MethodType, OutputType}() where 
        {StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} = new()
end

@inline function pcg_seed!(s::PCGStateOneseq{T}, init_state::T) where T <: PCGUInt
    s.state = 0 % T
    pcg_step!(s)
    s.state += init_state
    pcg_step!(s)
    s
end

# pcg_oneseq_XX_step_r
# XX is one of the UInt types.
@inline function pcg_step!(s::PCGStateOneseq{T}) where T <: PCGUInt
    s.state = s.state * default_multiplier(T) + default_increment(T)
end

# pcg_oneseq_XX_advance_r
# XX is one of the UInt types.
@inline function pcg_advance!(s::PCGStateOneseq{T}, delta::T) where T <: PCGUInt
    s.state = pcg_advance_lcg(s.state, delta, default_multiplier(T), default_increment(T))
end

# pcg_state_XX
# XX is one of the UInt types.
mutable struct PCGStateMCG{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
        AbstractPCG{StateType, MethodType, OutputType}
    state::StateType
    PCGStateMCG{StateType, MethodType, OutputType}() where
        {StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} = new()
end

@inline function pcg_seed!(s::PCGStateMCG{T}, init_state::T) where T <: PCGUInt
    s.state = init_state | 1
    s
end

# pcg_mcg_XX_step_r
# XX is one of the UInt types.
@inline function pcg_step!(s::PCGStateMCG{T}) where T <: PCGUInt
    s.state = s.state * default_multiplier(T)
end

# pcg_mcg_XX_advance_r
# XX is one of the UInt types.
@inline function pcg_advance!(s::PCGStateMCG{T}, delta::T) where T <: PCGUInt
    s.state = pcg_advance_lcg(s.state, delta, default_multiplier(T), 0 % T)
end

# pcg_state_XX
# XX is one of the UInt types.
mutable struct PCGStateUnique{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
        AbstractPCG{StateType, MethodType, OutputType}
    state::StateType
    PCGStateUnique{StateType, MethodType, OutputType}() where
        {StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} = new()
end

@inline function pcg_seed!(s::PCGStateUnique{T}, init_state::T) where T <: PCGUInt
    s.state = 0 % T
    pcg_step!(s)
    s.state += init_state
    pcg_step!(s)
    s
end

# pcg_unique_XX_step_r
# XX is one of the UInt types.
@inline function pcg_step!(s::PCGStateUnique{T}) where T <: PCGUInt
    s.state = s.state * default_multiplier(T) + (UInt(pointer_from_objref(s)) | 1) % T
end

# pcg_unique_XX_advance_r
# XX is one of the UInt types.
@inline function pcg_advance!(s::PCGStateUnique{T}, delta::T) where T <: PCGUInt
    s.state = pcg_advance_lcg(s.state, delta, default_multiplier(T),
        (UInt(pointer_from_objref(s)) | 1) % T)
end

# pcg_state_XX
# XX is one of the UInt types.
mutable struct PCGStateSetseq{StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} <:
        AbstractPCG{StateType, MethodType, OutputType}
    state::StateType
    inc::StateType
    PCGStateSetseq{StateType, MethodType, OutputType}() where
        {StateType<:PCGUInt, MethodType<:PCGMethod, OutputType<:PCGUInt} = new()
end

@inline function pcg_seed!(s::PCGStateSetseq{T}, init_state::T, init_seq::T) where T <: PCGUInt
    s.state = 0
    s.inc = (init_seq << 1) | 1
    pcg_step!(s)
    s.state += init_state
    pcg_step!(s)
    s
end

# pcg_setseq_XX_step_r
# XX is one of the UInt types.
@inline function pcg_step!(s::PCGStateSetseq{T}) where T <: PCGUInt
    s.state = s.state * default_multiplier(T) + s.inc
end

# pcg_setseq_XX_advance_r
# XX is one of the UInt types.
@inline function pcg_advance!(s::PCGStateSetseq{T}, delta::T) where T <: PCGUInt
    s.state = pcg_advance_lcg(s.state, delta, default_multiplier(T), s.inc)
end

"Return the output of a state for a certain PCG type."
pcg_output

"Initialize a PCG object."
pcg_seed!

"Do one iteration step for a PCG object."
pcg_step!

"Advance a PCG object."
pcg_advance!

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: AbstractRNG, gen_seed, seed_type


"""
```julia
SplitMix64 <: AbstractRNG{UInt64}
SplitMix64([seed])
```

Used for initializing a random seed.
"""
mutable struct SplitMix64 <: AbstractRNG{UInt64}
    x::UInt64
end
function SplitMix64(seed::Integer=gen_seed(UInt64))
    r = SplitMix64(zero(UInt64))
    seed!(r, seed)
    r
end

@inline seed_type(::Type{SplitMix64}) = UInt64

function copyto!(dest::SplitMix64, src::SplitMix64)
    dest.x = src.x
    dest
end

copy(src::SplitMix64) = copyto!(SplitMix64(zero(UInt64)), src)

==(r1::SplitMix64, r2::SplitMix64) = r1.x == r2.x

function seed!(r::SplitMix64, seed::Integer=gen_seed(UInt64))
    r.x = splitmix64(seed % UInt64)
    r
end

@inline function rand(r::SplitMix64, ::Type{UInt64})
    r.x = splitmix64(r.x)
end

@inline function splitmix64(x::UInt64)
    x += 0x9e3779b97f4a7c15
    x = (x ⊻ (x >> 30)) * 0xbf58476d1ce4e5b9
    x = (x ⊻ (x >> 27)) * 0x94d049bb133111eb
    x ⊻ (x >> 31)
end

init_seed(seed, ::Type{UInt64}) = splitmix64(seed % UInt64)
function init_seed(seed, ::Type{UInt64}, N::Int)
    x = seed % UInt64
    NTuple{N, UInt64}(
        x = splitmix64(x)
        for _ in 1:N
    )
end
function init_seed(seed, ::Type{UInt32}, N::Int)
    x = seed % UInt64
    NTuple{N, UInt32}(begin
        x = splitmix64(x)
        x % UInt32
    end for _ in 1:N)
end

import Random: GLOBAL_RNG

"""Random number generator for Float32 in [0,1) that samples from 
42*2^23 float32s in [0,1) compared to 2^23 for rand(Float32).""" 
function randfloat(rng::Random.AbstractRNG,::Type{Float32})
    # create exponent bits in 0000_0000 to 0111_1110
    # at following chances
    # e=01111110 at 50.0% for [0.5,1.0)
    # e=01111101 at 25.0% for [0.25,0.5)
    # e=01111100 at 12.5% for [0.125,0.25)
    # ...
    ui = rand(rng,UInt64)

    # count leading zeros of random UInt64
    # 0 leading zeros at 50% chance
    # 1 leading zero at 25% chance
    # 2 leading zeros at 12.5% chance etc.
    # then convert leading zeros to exponent bits of Float32
    lz = leading_zeros(ui)
    e = ((126 - lz) % UInt32) << 23

    # for 64 leading zeros the smallest float32 that can be created is 2.7105054f-20
    # use last 23 bits for signficand, only when they are not part of the leading zeros
    # to sample from all floats in 2.7105054f-20 to prevfloat(1f0)
    ui = lz > 40 ? rand(rng,UInt64) : ui

    # combine exponent and signficand
    return reinterpret(Float32,e | ((ui % UInt32) & 0x007f_ffff))
end

"""Random number generator for Float64 in [0,1) that samples from 
64*2^52 floats compared to 2^52 for rand(Float64).""" 
function randfloat(rng::Random.AbstractRNG,::Type{Float64})
    # create exponent bits in 000_0000_0000 to 011_1111_1110
    # at following chances
    # e=01111111110 at 50.0% for [0.5,1.0)
    # e=01111111101 at 25.0% for [0.25,0.5)
    # e=01111111100 at 12.5% for [0.125,0.25)
    # ...
    ui = rand(rng,UInt64)

    # count leading zeros of random UInt64 in several steps
    # 0 leading zeros at 50% chance
    # 1 leading zero at 25% chance
    # 2 leading zeros at 12.5% chance etc.
    # then convert leading zeros to exponent bits of Float64
    lz = leading_zeros(ui)
    e = ((1022 - lz) % UInt64) << 52

    # for 64 leading zeros the smallest float64 that
    # can be created is 2.710505431213761e-20

    # draw another UInt64 for significant bits in case the leading
    # zeros reach into the bits that would be used for the significand
    # (in which case the first signifcant bits would always be zero)
    ui = lz > 11 ? rand(rng,UInt64) : ui
    
    # combine exponent and significand (sign always 0)
    return reinterpret(Float64,e | (ui & 0x000f_ffff_ffff_ffff))
end

"""Random number generator for Float16 in [0,1) that samples from 
all 15360 float16s in that range.""" 
function randfloat(rng::Random.AbstractRNG,::Type{Float16})
    # create exponent bits in 00000 to 01110
    # at following chances
    # e=01110 at 50.0% for [0.5,1.0)
    # e=01101 at 25.0% for [0.25,0.5)
    # e=01100 at 12.5% for [0.125,0.25)
    # ...
    ui = rand(rng,UInt32) | 0x0002_0000
    # set 15th bit to 1 to have at most 14 leading zeros.

    # count leading zeros of random UInt64 in several steps
    # 0 leading zeros at 50% chance
    # 1 leading zero at 25% chance
    # 2 leading zeros at 12.5% chance etc.
    # then convert leading zeros to exponent bits of Float16
    lz = leading_zeros(ui)
    e = ((14 - lz) % UInt32) << 10
    
    # combine exponent and significand (sign always 0)
    return reinterpret(Float16,(e | (ui & 0x0000_03ff)) % UInt16)
end

# use stdlib default RNG as a default here too
randfloat(::Type{T}=Float64) where {T<:Base.IEEEFloat} = randfloat(GLOBAL_RNG,T)
randfloat(rng::Random.AbstractRNG) = randfloat(rng,Float64)

# randfloat for arrays - in-place
function randfloat!(rng::Random.AbstractRNG, A::AbstractArray{T}) where T
    for i in eachindex(A)
        @inbounds A[i] = randfloat(rng, T)
    end
    A
end

# randfloat for arrays with memory allocation
randfloat(rng::Random.AbstractRNG, ::Type{T}, dims::Integer...) where {T<:Base.IEEEFloat} = randfloat!(rng, Array{T}(undef,dims))
randfloat(rng::Random.AbstractRNG,            dims::Integer...)                           = randfloat!(rng, Array{Float64}(undef,dims))
randfloat(::Type{T}, dims::Integer...) where {T<:Base.IEEEFloat} = randfloat!(GLOBAL_RNG, Array{T}(undef,dims))
randfloat(           dims::Integer...)                           = randfloat!(GLOBAL_RNG, Array{Float64}(undef,dims))

const TEST_NAME = "PCG_XSH_RS_128_64"

include("common.jl")

using RandomNumbers.PCG

r = PCGStateSetseq(UInt64, PCG_XSH_RS,
    (0x4e17a5abd5d47402ce332459f69eacfd, 0x96856028d0dc791c176537f21a77ab67))

test_all(r, 100_000_000)

__precompile__(true)

"""
Main module for `RandomNumbers.jl` -- a random number generator package for Julia Language.


This module exports two types and four submodules:

- [`AbstractRNG`](@ref)
- [`WrappedRNG`](@ref)
- [`PCG`](@ref)
- [`MersenneTwisters`](@ref)
- [`Random123`](random123.md#Random123.Random123)
- [`Xorshifts`](@ref)
"""
module RandomNumbers

    export AbstractRNG
    export WrappedRNG
    export output_type, seed_type
    export PCG, MersenneTwisters, Random123, Xorshifts

    include("common.jl")
    include("utils.jl")
    
    include("wrapped_rng.jl")

    include(joinpath("PCG", "PCG.jl"))
    include(joinpath("MersenneTwisters", "MersenneTwisters.jl"))
    include(joinpath("Xorshifts", "Xorshifts.jl"))

    export randfloat
    include("randfloat.jl")

    import Requires
    function __init__()
        # The code of Random123 has been moved to Random123.jl
        Requires.@require Random123="74087812-796a-5b5d-8853-05524746bad3" import .Random123
    end

end

using Test

if !@isdefined RandomNumbers
    include("../common.jl")
end

@testset "MersenneTwisters" begin

    using RandomNumbers.MersenneTwisters

    @info "Testing MersenneTwisters"
    stdout_ = stdout
    pwd_ = pwd()
    cd(dirname(@__FILE__))
    rm("./actual"; force=true, recursive=true)
    mkpath("./actual")

    @test seed_type(MT19937) == NTuple{RandomNumbers.MersenneTwisters.N, UInt32}

    for mt_name in (:MT19937, )

        outfile = open(string(
            "./actual/check-$(lowercase("$mt_name")).out"
        ), "w")
        redirect_stdout(outfile)

        @eval $mt_name()
        x = @eval $mt_name(123)
        @test copyto!(copy(x), x) == x

        for i in 1:100
            @printf "%.9f\n" rand(x)
        end

        close(outfile)
    end
    redirect_stdout(stdout_)

    compare_dirs("expected", "actual")

    # Package content should not be modified.
    rm("./actual"; force=true, recursive=true)

    cd(pwd_)

end

using Test

if !@isdefined RandomNumbers
    include("../common.jl")
end

@testset "PCG" begin

    using RandomNumbers.PCG

    @info "Testing PCG"
    stdout_ = stdout
    pwd_ = pwd()
    cd(dirname(@__FILE__))
    rm("./actual"; force=true, recursive=true)
    mkpath("./actual")

    numbers = ['A', '2', '3', '4', '5', '6', '7', '8', '9', 'T', 'J', 'Q', 'K']
    suit = ['h', 'c', 'd', 's'];

    PCGStateOneseq()
    PCGStateOneseq(UInt32)
    PCGStateMCG()
    PCGStateMCG(UInt32)
    PCGStateSetseq()
    PCGStateSetseq(UInt32)
    PCGStateUnique()
    PCGStateUnique(UInt32)

    for (state_type_t, uint_type, method_symbol, return_type) in PCG_LIST
        state_type = eval(Symbol("PCGState$state_type_t"))
        method = Val{method_symbol}

        state_type(method)
        state_type(return_type, method)

        if state_type_t == :Setseq
            r = state_type(return_type, method, (42, 54))
            @test seed_type(r) == NTuple{2, uint_type}
        else
            r = state_type(return_type, method, 42)
            @test seed_type(r) == uint_type
        end
        @test copyto!(copy(r), r) == r

        # Unique state won't produce the same sequence every time.
        if state_type_t == :Unique
            t = rand(r, return_type)
            advance!(r, -1)
            @test t == rand(r, return_type)
            bounded_rand(r, 200701281 % return_type)
            continue
        end
        outfile = open(string(
            "./actual/check-$(lowercase("$state_type_t"))-$(sizeof(uint_type) << 3)-",
            "$(replace(lowercase("$method_symbol"), "_" => "-"))-$(sizeof(return_type) << 3).out"
        ), "w")
        redirect_stdout(outfile)
        for round in 1:5
            @printf "Round %d:\n" round
            @printf "%4dbit:" (sizeof(return_type) << 3)
            values = 10
            wrap = 10
            printstr = " 0x%04x"
            if return_type == UInt8
                values, wrap, printstr = 14, 14, " 0x%02x"
            elseif return_type == UInt32
                values, wrap, printstr = 6, 6, " 0x%08x"
            elseif return_type == UInt64
                values, wrap, printstr = 6, 3, " 0x%016llx"
            elseif return_type == UInt128
                values, wrap, printstr = 6, 2, " 0x%032llx"
            end

            for i in 1:values
                if i > 1 && (i - 1) % wrap == 0
                    @printf "\n\t"
                end
                value = rand(r, return_type)
                @eval @printf $printstr $value
            end
            @printf "\n"

            @printf "  Again:"
            advance!(r, -(values % uint_type))
            for i in 1:values
                if i > 1 && (i - 1) % wrap == 0
                    @printf "\n\t"
                end
                value = rand(r, return_type)
                @eval @printf $printstr $value
            end
            @printf "\n"

            @printf "  Coins: "
            for i in 1:65
                @printf "%c" (bounded_rand(r, 2 % return_type) == 1 ? 'H' : 'T')
            end
            @printf "\n"

            @printf "  Rolls:"
            for i in 1:33
                @printf " %d" (UInt32(bounded_rand(r, 6 % return_type)) + 1);
            end
            @printf "\n"

            cards = collect(0:51)
            for i = 52:-1:2
                chosen = bounded_rand(r, i % return_type)
                card = cards[chosen+1]
                cards[chosen+1] = cards[i]
                cards[i] = card
            end

            @printf "  Cards:"
            for i = 0:51
                @printf " %c%c" numbers[(cards[i+1] ÷ 4)+1] suit[(cards[i+1] % 4)+1]
                if (i+1) % 22 == 0
                    @printf "\n\t"
                end
            end
            @printf "\n"

            @printf "\n"
        end
        close(outfile)
    end
    redirect_stdout(stdout_)

    compare_dirs("expected", "actual")

    # Package content should not be modified.
    rm("./actual"; force=true, recursive=true)

    cd(pwd_)

end

using Documenter, RandomNumbers, DocumenterMarkdown
import Random123

DocMeta.setdocmeta!(RandomNumbers, :DocTestSetup, quote
    using RandomNumbers
    using RandomNumbers.PCG
    using RandomNumbers.Xorshifts
    using RandomNumbers.MersenneTwisters
    using Random123
    using Test
end; recursive=true)

makedocs(
    modules = [RandomNumbers],
    format = Markdown()
)

deploydocs(
    repo   = "github.com/JuliaRandom/RandomNumbers.jl.git",
    deps   = Deps.pip("pygments", "mkdocs", "python-markdown-math", "mkdocs-material"),
    make = () -> run(`mkdocs build`),
    target = "site"
)

# Mersenne Twisters

```@meta
CurrentModule = RandomNumbers.MersenneTwisters
DocTestSetup = quote
    using RandomNumbers.MersenneTwisters
    r = MT19937(Tuple(UInt32(i) for i in 1:624))
end
```

The **Mersenne Twister**[^1] is so far the most widely used PRNG. Mersenne Twisters are taken as default
random number generators of a great many of software systems, including the Julia language until the current
1.0 version. The most commonly used version of Mersenne Twisters is **MT19937**, which has a very long period
of ``2^{19937}-1`` and passes numerous tests including the Diehard tests.

However, it also has many flaws by today's standards. For the large period, MT19937 has to use a 2.5 KiB
state buffer, which place a load on the memory caches. More severely, it cannot pass all the TestU01
statistical tests[^2], and the speed is not so fast. **So it is not recommended in most situations.**

The [`MersenneTwisters`](@ref) in this package currently only provides one RNG: [`MT19937`](@ref). `MT19937`
can only produce `UInt32` numbers as output. Its state is an array of 624 `UInt32` numbers, so it takes 624
`UInt32`s as seed. A default function is also provided to deal with one `UInt32` as seed.

## Examples

To use the Mersenne Twisters, firstly import the module:
```jldoctest
julia> using RandomNumbers.MersenneTwisters
```

A certain sequence can be used to initialize an instance of MT19937:
```jldoctest
julia> seed = Tuple(UInt32(i) for i in 1:624);  # This is a Tuple of 1..624

julia> r = MT19937(seed);
```
Since MT19937 is a RNG based on linear-feedback shift-register techniques, this approach is not recommended
for an obivous reason:
```jldoctest
julia> rand(r, UInt32, 10)
10-element Array{UInt32,1}:
 0x23864fee
 0xdd51a593
 0x20c049a2
 0xde17a3df
 0x20804931
 0xde57a34c
 0x20c049a0
 0xde17a3dd
 0x20804933
 0xde57a34e
```
The firstly generated numbers are so poorly random. This is because the most bits of states are zeros. So it
is better to create a `MT19937` in this way:
```jldoctest
julia> r = MT19937();
```
In this case, all the 624 states will be filled with truly random numbers produced by `RandomDevice`. If
someone needs the reproducibility, just save the state `r.mt` and use it for next time.

An initialization function described in the original paper[^1] is also implemented here, so the seed can also
be just one `UInt32` number (or an `Integer` whose least 32 bits will be truncated):
```jldoctest
julia> import Random

julia> Random.seed!(r, 0xabcdef12);

julia> rand(r, UInt32, 10)
10-element Array{UInt32,1}:
 0x986c5150
 0xbb9e20f5
 0xfb59a25a
 0x189eb49c
 0xbcca5395
 0x48d9fdf5
 0x3193f581
 0xe0b6d080
 0x63154ca2
 0x72b28f0d
```
Note that if you use one `UInt32` number as seed, you will always get in a bias way.[^3]

[^1]:
    Matsumoto M, Nishimura T. Mersenne twister: a 623-dimensionally equidistributed uniform pseudo-random
    number generator[J]. ACM Transactions on Modeling and Computer Simulation (TOMACS), 1998, 8(1): 3-30.
    doi:[10.1145/272991.272995](https://dx.doi.org/10.1145/272991.272995).

[^2]:
    L'Ecuyer P, Simard R. TestU01: AC library for empirical testing of random number generators[J]. ACM
    Transactions on Mathematical Software (TOMS), 2007, 33(4): 22.
    doi:[10.1145/1268776.1268777](http://dx.doi.org/10.1145/1268776.1268777)

[^3]:
    [C++ Seeding Surprises](http://www.pcg-random.org/posts/cpp-seeding-surprises.html)

# Basics

This page describes basic concepts and fundamental knowledge of **RandomNumbers.jl**.

!!! note
    Unless otherwise specified, all the random number generators in this package are *pseudorandom* number
    generators (or *deterministic* random bit generator), which means they only provide numbers whose
    properties approximate the properties of *truly random* numbers. Always, especially in secure-sensitive
    cases, keep in mind that they do not gaurantee a totally random performance.

## Installation

This package is registered. The stable version of this package requires Julia `0.7+`. You can install it by:
```julia
(v1.0) pkg> add RandomNumbers
```

It is recommended to run the test suites before using the package:
```julia
(v1.0) pkg> test RandomNumbers
```

## Interface

First of all, to use a RNG from this package, you can import `RandomNumbers.jl` and use RNG by declare its
submodule's name, or directly import the submodule. Then you can create a random number generator of certain
type. For example:

```julia
julia> using RandomNumbers
julia> r = Xorshifts.Xorshift1024Plus()
```
or
```julia
julia> using RandomNumbers.Xorshifts
julia> r = Xorshift1024Plus()
```

The submodules have some API in common and a few differently.

All the Random Number Generators (RNGs) are child types of `AbstractRNG{T}`, which is a child type of
`Base.Random.AbstractRNG` and replaces it. (`Base.Random` may be refactored sometime, anyway.) The type
parameter `T` indicates the original output type of a RNG, and it is usually a child type of `Unsigned`, such
as `UInt64`, `UInt32`, etc. Users can change the output type of a certain RNG type by use a wrapped type:
[`WrappedRNG`](@ref).

Consistent to what `Base.Random` does, there are generic functions:

- `seed!(::AbstractRNG{T}[, seed])`
    initializes a RNG by one or a sequence of numbers (called *seed*). The output sequences by two RNGs of
    the same type should be the same if they are initialized by the same seed, which makes them
    *deterministic*. The seed type of each RNG type can be different, you can refer to the corresponding
    manual pages for details. If no `seed` provided, then it will use [`RandomNumbers.gen_seed`](@ref) to get
    a "truly" random one.

- `rand(::AbstractRNG{T}[, ::Type{TP}=Float64])`
    returns a random number in the type `TP`. `TP` is usually an `Unsigned` type, and the return value is
    expected to be uniformly distributed in {0, 1} at every bit. When `TP` is `Float64` (as default), this
    function returns a `Float64` value that is expected to be uniformly distributed in ``[0, 1)``. The
    discussion about this is in the [Conversion to Float](@ref) section.

The other common functions such as `rand(::AbstractRNG, ::Dims)` and `rand!(::AbstractRNG, ::AbstractArray)`,
and the ones that generate random numbers in a certain distribution such as `randn`, `randexp`, `randcycle`,
etc. defined in the standard library `Random` still work well.
See the [official docs](https://docs.julialang.org/en/latest/stdlib/Random/) for details. You can also refer
to [this section](@ref common-functions) for the common functions.

The constructors of all the types of RNG are designed to take the same kind of parameters as `seed!`. For example:

```jldoctest
julia> using RandomNumbers.Xorshifts

julia> import Random: rand!

julia> r1 = Xorshift128Star(123)  # Create a RNG of Xorshift128Star with the seed "123"
Xorshift128Star(0x000000003a300074, 0x000000003a30004e)

julia> r2 = Xorshift128Star();  # Use a random value to be the seed.

julia> rand(r1)  # Generate a number uniformly distributed in ``[0, 1)``.
0.2552720033868119

julia> A = rand(r1, UInt64, 2, 3)  # Generate a 2x3 matrix `A` in `UInt64` type.
2×3 Array{UInt64,2}:
 0xbed3dea863c65407  0x607f5f9815f515af  0x807289d8f9847407
 0x4ab80d43269335ee  0xf78b56ada11ea641  0xc2306a55acfb4aaa

julia> rand!(r1, A)  # Refill `A` with random numbers.
2×3 Array{UInt64,2}:
 0xf729352e2a72b541  0xe89948b5582a85f0  0x8a95ebd6aa34fcf4
 0xc0c5a8df4c1b160f  0x8b5269ed6c790e08  0x930b89985ae0c865
```

People will get the same results in their own computers of the above lines. For
more interfaces and usage examples, please refer to the manual pages of each RNG.


## Empirical Statistical Testing

Empirical statistical testing is very important for random number generation, because the theoretical
mathematical analysis is insufficient to verify the performance of a random number generator.

The famous and highly evaluated [**TestU01** library](http://simul.iro.umontreal.ca/testu01/tu01.html) is
chosen to test the RNGs in `RandomNumbers.jl`. **TestU01** offers a collection of test suites, and
*Big Crush* is the largest and most stringent test battery for empirical testing (which usually takes several
hours to run). *Big Crush* has revealed a number of flaws of lots of well-used generators, even including the
*Mersenne Twister* (or to be more exact, the *dSFMT*) which is currently used in `Base.Random` as
GLOBAL_RAND`.[^1]

This package chooses [RNGTest.jl](https://github.com/andreasnoack/RNGTest.jl) to use TestU01.

The testing results are available on [Benchmark](@ref) page.

[^1]:
    [`rand` fails bigcrush #6464](https://github.com/JuliaLang/julia/issues/6464)


## Conversion to Float

Besides the statistical flaws, popular generators often neglect the importance of converting unsigned
integers to floating numbers. The most common situation is to convert an `UInt` to a `Float64` which is
uniformly distributed in ``[0.0, 1.0)``. For example, neither the `std::uniform_real_distribution` in
libstdc++ from gcc, libc++ from llvm, nor the standard library from MSVC has a correct performance, as they
all have a non-zero probability for generating the max value which is an open bound and should not be
produced.

The cause is that a `Float64` number in ``[0.0, 1.0)`` has only 53 *significand* bits (52 explicitly stored),
which means at least 11 bits of an `UInt64` are abandoned when being converted to `Float64`. If using the
naive approach to multiply an `UInt64` by ``2^{-64}``, users may get 1.0, and the distribution is not good
(although using ``2^{-32}`` for an `UInt32` is OK).

In this package, we make use of the fact that the distribution of the least 52 bits can be the same in an
`UInt64` and a `Float64` (if you are familiar with
[IEEE 754](https://en.wikipedia.org/wiki/IEEE_floating_point) this is easy to understand). An `UInt64` will
firstly be converted to a `Float64` that is perfectly uniformly distributed in [1.0, 2.0), and then subtract
one. This is a very fast approach, but not completely ideal, as the statistics of the least significant bits
are affected. Due to rounding in the subtraction,

- the least significant bit of `rand()` is always 0, the second last is only at 25% a 1, the third last bit is at 37.5% chance a 1, the n-th last bit is at p=1/2-2^(-n) chance a 1. In practice, this only affects the last few bits, but holds for `rand(Float32)` as well as for `rand(Float64)`.
- the sampling is not from all floats in [0,1) but only from 2^23 (Float32) or 2^52 (Float64).
- The subset of floats which is sampled from is every second float in [1/2,1), every 4th in [1/4,1/2), so every 2n-th in [1/2n,1/n).
- The smallest positive float (but note that 0f0/0.0 is also possible) that is sampled is `eps(Float32)=1.1920929f-7` (Float32) or `eps(Float64)=2.220446049250313e-16` (Float64).

The current default RNG in `Base.Random` library does the same thing, so it also causes some tricky problems.[^2]

To address some of these issues RandomNumbers.jl also provides `randfloat()` for `Float16`, `Float32` and `Float64`,
which

- has full entropy for all significant bits, i.e. 0 and 1 always occur at 50% chance
- samples from all floats in [2.7105054f-20,1) (Float32) and [2.710505431213761e-20,1) (Float64) and true [0,1) (Float16, including correct chances for subnormals) 
- As the true chance to obtain a 0 in [0,1) for floats is effectively 0, it is practically also 0 for randfloat (except for Float16).
- is about 20% slower than `rand`, see [#72](https://github.com/sunoru/RandomNumbers.jl/issues/72)

`randfloat()` is not based on the `[1,2) minus one`-approach but counts the leading zeros of a random `UInt` to obtain
the correct chances for the exponent bits (which are 50% for 01111110 meaning [1/2,1) in float32, 25% for 01111101
meaning [1/4,1/2), etc.). This is combined with random `UInt` bits for the significand.

[^2]:
    [Least significant bit of rand() is always zero #16344](https://github.com/JuliaLang/julia/issues/16344)

# Xorshift Family

```@meta
CurrentModule = RandomNumbers.Xorshifts
```
[`Xorshift`](http://xoroshiro.di.unimi.it/) family is a class of PRNGs based on linear transformation that
takes the *exclusive or* of a number with a *bit-shifted* version of itself[^1]. They are extremely fast on
mordern computer architectures, and are very suitable for non-cryptographically-secure use. The suffix `-Star`
and `-Plus` in the RNG names denote to two classes of improved RNGs[^2][^3], which make it to pass Big Crush
in TestU01. `-Star` RNGs are obtained by scrambling the output of a normal `Xorshift` generator with a 64-bit
invertible multiplier, while `-Plus` RNGs return the sum of two consecutive output of a `Xorshift` generator.

In this package there are four series of RNG types:

- [`Xorshift64`](@ref) and [`Xorshift64Star`](@ref):
    They have a period of ``2^{64}``, but not recommended because 64 bits of state are not enough for any
    serious purpose.

- [`Xorshift128`](@ref), [`Xorshift128Star`](@ref) and [`Xorshift128Plus`](@ref):
    They have a period of ``2^{128}``. `Xorshift128Plus` is presently used in the JavaScript engines of
    Chrome, Firefox and Safari.

- [`Xorshift1024`](@ref), [`Xorshift1024Star`](@ref) and [`Xorshift1024Plus`](@ref):
    They have a long period of ``2^{1024}``, and takes some more space for storing the state. If you are
    running large-scale parallel simulations, it's a good choice to use `Xorshift1024Star`.

- [`Xoroshiro128`](@ref), [`Xoroshiro128Star`](@ref) and [`Xoroshiro128Plus`](@ref):
    The successor to `Xorshift128` series. They make use of a carefully handcrafted shift/rotate-based linear
    transformation, resulting in a significant improvement in speed and in statistical quality. Therefore,
    `Xoroshiro128Plus` is the current best suggestion for replacing other low-quality generators.

```@meta
CurrentModule = RandomNumbers
```
All the RNG types produce `UInt64` numbers, if you have need for other output type, see [`WrappedRNG`](@ref).

## Examples
The usage of `Xorshift` family is very simple and common:

```jldoctest
julia> using RandomNumbers.Xorshifts

julia> r = Xoroshiro128Plus();  # create a RNG with truly random seed.

julia> r = Xoroshiro128Plus(0x1234567890abcdef)  # with a certain seed. Note that the seed must be non-zero.
Xoroshiro128Plus(0xe7eb72d97b4beac6, 0x9b86d56534ba1f9e)

julia> rand(r)
0.14263790854661185

julia> rand(r, UInt32)
0x0a0315b3
```

[^1]:
    Marsaglia G. Xorshift rngs[J]. Journal of Statistical Software, 2003, 8(14): 1-6.
    doi:[10.18637/jss.v008.i14](http://dx.doi.org/10.18637/jss.v008.i14)

[^2]:
    Vigna S. An experimental exploration of Marsaglia's xorshift generators, scrambled[J]. arXiv preprint
    [arXiv:1402.6246](http://arxiv.org/abs/1402.6246), 2014.

[^3]:
    Vigna S. Further scramblings of Marsaglia's xorshift generators[J]. arXiv preprint
    [arXiv:1404.0390](http://arxiv.org/abs/1404.0390), 2014.

# Random123

## Index
```@index
Pages = ["random123.md"]
```

## Public
```@autodocs
Modules = [RandomNumbers.Random123]
Private = false
```

## Internal
```@autodocs
Modules = [RandomNumbers.Random123]
Public = false
```

# Benchmark

```@meta
CurrentModule = RandomNumbers
```

This page includes the results of speed tests and big crush tests of several kinds of RNGs in this package.
The data is produced on such a computer:
```julia
julia> versioninfo()
Julia Version 0.5.0-rc0+0
Commit 633443c (2016-08-02 00:53 UTC)
Platform Info:
  System: Linux (x86_64-redhat-linux)
  CPU: Intel(R) Core(TM) i5-3470 CPU @ 3.20GHz
  WORD_SIZE: 64
  BLAS: libopenblas (USE64BITINT DYNAMIC_ARCH NO_AFFINITY Sandybridge)
  LAPACK: libopenblas64_
  LIBM: libopenlibm
  LLVM: libLLVM-3.7.1 (ORCJIT, ivybridge)
```
All the benchmark scripts are in the [benchmark](https://github.com/sunoru/RandomNumbers.jl/tree/master/benchmark)
directory, you can do the tests by yourself.

!!!note
    All the data here is only for reference, and will be updated as this package is updated.

## Speed Test

The speed test results are as following (the smaller is the better):

![Speed Test](./img/speed_test.svg)

and detailed in the table (sorted by speed):

|RNG Type|Speed (ns/64 bits)|RNG Type|Speed (ns/64 bits)|RNG Type|Speed (ns/64 bits)|
|---|:-:|---|:-:|---|:-:|
|Xoroshiro128Star|1.184|PCG\_XSL\_RR\_128|2.646|Philox4x64|5.737|
|Xorshift128Plus|1.189|PCG\_XSH\_RS\_64|2.738|Threefry4x64|5.965|
|Xoroshiro128Plus|1.393|PCG\_XSH\_RR\_128|3.260|Threefry2x64|7.760|
|Xorshift128Star|1.486|PCG\_XSL\_RR\_64|3.308|Philox2x32|9.698|
|PCG\_RXS\_M\_XS\_64|1.522|PCG\_XSH\_RS\_128|3.373|Philox4x32|11.517|
|PCG\_XSL\_RR\_RR\_128|1.602|PCG\_RXS\_M\_XS\_32|3.420|Threefry4x32|12.241|
|Xorshift64|1.918|PCG\_XSH\_RR\_64|3.580|Threefry2x32|16.253|
|BaseMT19937\*|1.971|Xorshift1024Plus|3.725|ARS1x128|17.081|
|Xorshift64Star|2.000|Xorshift1024Star|3.748|ARS4x32|18.059|
|PCG\_XSL\_RR\_RR\_64|2.044|MT19937|4.229|AESNI1x128|18.304|
|PCG\_RXS\_M\_XS\_128|2.482|Philox2x64|5.161|AESNI4x32|29.770|

\*`BaseMT19937` denotes to `Base.Random.MersenneTwister`.

## Big Crush Test

10 kinds of RNGs (which are worth considering) have been tested with Big Crush test batteries:

|RNG Type|Speed (ns/64 bits)|Total CPU time|Failed Test(s)\*|
|---|:-:|:-:|---|
|AESNI1x128|18.304|04:14:22.19| |
|ARS1x128|17.081|04:13:27.54|55 SampleCorr, k = 1 p-value = 7.0e-4|
|BaseMT19937|1.971|03:18:23.47| |
|MT19937|4.229|03:32:59.06|36 Gap, r = 0 p-value = eps<br>80LinearComp, r = 0 p-value = 1-eps1<br>81  LinearComp, r = 29 p-value = 1-eps1|
|PCG\_RXS\_M\_XS\_64\_64|1.522|03:20:07.97| |
|PCG\_XSH\_RS\_128\_64|3.373|03:24:57.54|54  SampleMean, r = 10              0.9991|
|Philox2x64|5.737|03:28:52.27|35  Gap, r = 25  3.4e-4|
|Threefry2x64|5.965|03:37:53.53| |
|Xoroshiro128Plus|1.393|03:33:16.51| |
|Xorshift1024Star|3.748|03:39:15.19| |
\*eps means a value < 1.0e-300, and eps1 means a value < 1.0e-15.

It is interesting that BaseMT19937 passes all the tests when generating `UInt64` (by generating two `UInt32`
with dSFMT). The PCG ones do not pass all the tests as the paper says, but the failures are just near the
threshold. The RNG with best performance here is `Xoroshiro128Plus`, which passes all the tests and has an
excellent speed.

# MersenneTwisters

## Index
```@index
Pages = ["mersenne-twisters.md"]
```

## Public
```@autodocs
Modules = [RandomNumbers.MersenneTwisters]
Private = false
```

## Internal
```@autodocs
Modules = [RandomNumbers.MersenneTwisters]
Public = false
```

# TODO

## General
- Redesign the framework of RNG in Julia Base.
    - `advance!` function whenever possible.
    - `copy` and `copyto!`.
- Help improve `Distributions.jl`.

## PCG
- Implement the extended version of PCG generators, which supports larger periods.
- Figure out the performance issue of `PCG_XSH_RS`: it is expected to run faster than `PCG_RXS_M_XS`.

## Mersenne Twisters
- Implement the 64-bit version of `MT19937`.

## Random123
- Make use of `CUDA` or `OpenCL`.
- Improve the performance.
- Store counters in a better way.

## Wrapped RNG
- A function to be constructed from another `WrappedRNG`.

## Others
- Perhaps consider implementing `arc4random` or `Chacha20`, which is slow but cryptographically secure.
- Something like `seed_seq` in C++.
- Test submodules separately.

# RandomNumbers

## Index
```@index
Pages = ["random-numbers.md"]
```

## [Common Functions](@id common-functions)
- [Base.rand](https://docs.julialang.org/en/v1/stdlib/Random/#Base.rand)
- [Random.rand!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.rand!)
- [Random.seed!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.seed!)
- [Base.randn](https://docs.julialang.org/en/v1/stdlib/Random/#Base.randn)
- [Random.randn!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randn!)
- [Random.randexp](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randexp)
- [Random.randexp!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randexp!)
- [Random.bitrand](https://docs.julialang.org/en/v1/stdlib/Random/#Random.bitrand)
- [Random.randstring](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randstring)
- [Random.randsubseq](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randsubseq)
- [Random.randsubseq!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randsubseq!)
- [Random.randperm](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randperm)
- [Random.randperm!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randperm!)
- [Random.randcycle](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randcycle)
- [Random.randcycle!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.randcycle!)
- [Random.shuffle](https://docs.julialang.org/en/v1/stdlib/Random/#Random.shuffle)
- [Random.shuffle!](https://docs.julialang.org/en/v1/stdlib/Random/#Random.shuffle!)

## Public
```@autodocs
Modules = [RandomNumbers]
Private = false
```

## Internal
```@autodocs
Modules = [RandomNumbers]
Public = false
```

# Xorshifts

## Index
```@index
Pages = ["xorshifts.md"]
```

## Public
```@autodocs
Modules = [RandomNumbers.Xorshifts]
Private = false
```

## Internal
```@autodocs
Modules = [RandomNumbers.Xorshifts]
Public = false
```

# PCG Family

```@meta
CurrentModule = RandomNumbers.PCG
DocTestSetup = quote
    using RandomNumbers.PCG
    r = PCGStateOneseq(1234567)
end
```

**[Permuted Congruential Generators](http://www.pcg-random.org/)** (PCGs) are a family of RNGs which uses a
*linear congruential generator* as the state-transition function, and uses *permutation functions on tuples*
to produce output that is much more random than the RNG's internal state.[^1]

## PCG Type

Each PCG generator is available in four variants, based on how it applies the additive constant for its
underlying LCG; the variations are:

- [`PCGStateOneseq`](@ref) (single stream):
    all instances use the same fixed constant, thus the RNG always somewhere in same sequence.
- [`PCGStateMCG`](@ref) (mcg):
    adds zero, resulting in a single stream and reduced period.
- [`PCGStateSetseq`](@ref) (specific stream):
    the constant can be changed at any time, selecting a different random sequence.
- [`PCGStateUnique`](@ref) (unique stream):
    the constant is based on the memory address of the object, thus every RNG has its own unique sequence.

## PCG Method Type

- [`PCG_XSH_RS`](@ref): high xorshift, followed by a random shift.
    It's fast and is a good performer.
- [`PCG_XSH_RR`](@ref): high xorshift, followed by a random rotate.
    It's fast and is a good performer. Slightly better statistically than `PCG_XSH_RS`.
- [`PCG_RXS_M_XS`](@ref): fixed xorshift (to low bits), random rotate.
    The most statistically powerful generator, but all those steps make it slower than some of the others.
    (but in this package the benchmark shows it's even fast than `PCG_XSH_RS`, which is an current issue.)
- [`PCG_XSL_RR`](@ref): fixed xorshift (to low bits), random rotate.
    Useful for 128-bit types that are split across two CPU registers.
- [`PCG_XSL_RR_RR`](@ref): fixed xorshift (to low bits), random rotate (both parts).
    Useful for 128-bit types that are split across two CPU registers. Use this in need of an invertable
    128-bit RNG.

## Interface and Examples

An instance of PCG generator can be created by specify the state type, the output type, the method and seed.
When seed is missing it is set to truly random numbers. The default output type is `UInt64`, and the default
method is `PCG_XSH_RS`. The seed will be converted to the internal state type (a kind of unsigned integer),
and for PCGs with specific stream (`PCGStateSetseq`) the seed should be a `Tuple` of two `Integer`s. Note that
not all parameter combinations are available (see [`PCG_LIST`](@ref)). For example:
```jldoctest
julia> using RandomNumbers.PCG

julia> PCGStateOneseq(UInt64, 1234567)  # create a single stream PCG, specifying the output type and seed.
PCGStateOneseq{UInt128,Val{:XSH_RS},UInt64}(0xa10d40ffc2b1e573e589b22b2450d1fd)

julia> PCGStateUnique(PCG_RXS_M_XS, 1234567);  # unique stream PCG, specifying the method and seed.

julia> PCGStateSetseq(UInt32, PCG_XSH_RR, (1234567, 7654321))
PCGStateSetseq{UInt64,Val{:XSH_RR},UInt32}(0xfc77de2cd901ff85, 0x0000000000e99763)
```

[`bounded_rand`](@ref) is provided by this module, in which the bound is must an integer in the output type:
```jldoctest
julia> r = PCGStateOneseq(1234567)
PCGStateOneseq{UInt128,Val{:XSH_RS},UInt64}(0xa10d40ffc2b1e573e589b22b2450d1fd)

julia> [bounded_rand(r, UInt64(100)) for i in 1:6]
6-element Array{UInt64,1}:
 0x0000000000000012
 0x000000000000000a
 0x000000000000002e
 0x0000000000000049
 0x0000000000000043
 0x000000000000002b
```

PCG also has an [`advance!`](@ref) function, used to advance the state of a PCG instance.
```jldoctest
julia> import Random

julia> Random.seed!(r, 1234567);

julia> rand(r, 4)
4-element Array{Float64,1}:
 0.5716257379273757
 0.9945058856417783
 0.8886220302794352
 0.08763836824057081

julia> advance!(r, -4);

julia> rand(r, 4)
4-element Array{Float64,1}:
 0.5716257379273757
 0.9945058856417783
 0.8886220302794352
 0.08763836824057081
```

[^1]:
    O’NEILL M E. PCG: A Family of Simple Fast Space-Efficient Statistically Good Algorithms for Random Number Generation[J].

# RandomNumbers.jl Documentation

**RandomNumbers.jl** is a collection of Random Number Generators for the Julia language.

There are several kinds of RNG families in this package, provided as submodules.

The examples and detailed descriptions of each RNG can be found on the Manual pages.

## Manual Outline
```@contents
Pages = [
    "man/basics.md",
    "man/benchmark.md",
    "man/pcg.md",
    "man/mersenne-twisters.md",
    "man/random123.md",
    "man/xorshifts.md",
    "man/ref.md",
]
Depth = 2
```

## Library Outline
```@contents
Pages = [
    "lib/random-numbers.md",
    "lib/pcg.md",
    "lib/mersenne-twisters.md",
    "lib/random123.md",
    "lib/xorshifts.md",
]
Depth = 2
```

# Random123 Family

```@meta
CurrentModule = RandomNumbers.Random123
DocTestSetup = quote
    using RandomNumbers.Random123
end
```

**[Random123](https://www.deshawresearch.com/resources_random123.html)** is a library of "counter-based"
random number generators (CBRNGs), developed by D.E.Shaw Research[^1]. *Counter-based* means the RNGs in this
family can produce the ``\mathrm{N}^\textrm{th}`` number by applying a stateless mixing function to the *counter*
``\mathrm{N}``, instead of the conventional approach of using ``\mathrm{N}`` iterations of a stateful
transformation. The current version of Random123 in this package is 1.09, and there are four kinds of RNGs:
[Threefry](@ref), [Philox](@ref), [AESNI](@ref), [ARS](@ref).

The original paper[^1] says all the RNGs in Random123 can pass Big Crush in TestU01, but in the
[benchmark](@ref Benchmark) we did, `ARS1x128` and `Philox2x64` have a slight failure.

## Random123 RNGs

All the RNG types in Random123 have a property `ctr1`, which denotes to its first *counter*, and some of them
have `ctr2` for the second *counter*. The suffix '-1x', '-2x' and '-4x' indicates how many numbers will be
generated per time. The first one or two or four properties of a RNG type in Random123 are
always `x`(or `x1`, `x2`, etc.), which denote to the produced numbers.

### Threefry

`Threefry` is a **non-cryptographic** adaptation of the Threefish block cipher from the
[Skein Hash Function](http://www.skein-hash.info/).

In this package, there are two `Type`s of `Threefry`: [`Threefry4x`](@ref) and [`Threefry2x`](@ref). Besides
the output type `T`, there is another parameter `R`, which denotes to the number of rounds, and must be at
least 1 and no more than 32. With 20 rounds (by default), `Threefry` has a considerable safety margin over
the minimum number of rounds with no known statistical flaws, but still has excellent performance. They both
support `UInt32` and `UInt64` output.

### Philox

`Philox` uses a Feistel network and integer multiplication.

`Philox` also has two `Type`s: [`Philox4x`](@ref) and [`Philox2x`](@ref). The number of rounds must be at
least 1 and no more than 16. With 10 rounds (by default), Philox2x32 has a considerable safety margin over
the minimum number of rounds with no known statistical flaws, but still has excellent performance. They both
support `UInt32` and `UInt64` output.

### AESNI

`AESNI` uses the Advanced Encryption Standard (AES) New Instruction, available on certain modern x86
processors (some models of Intel Westmere and Sandy Bridge, and AMD Interlagos, as of 2011). AESNI CBRNGs can
operate on `UInt128` type.

`AESNI` has two `Type`s: [`AESNI1x`](@ref) and [`AESNI4x`](@ref). `AESNI4x` only internally converts
`UInt128` to `UInt32`.

### ARS

`ARS` (Advanced Randomization System) is a **non-cryptographic** simplification of [AESNI](@ref).

`ARS` has two `Type`s: [`ARS1x`](@ref) and [`ARS4x`](@ref). `ARS4x` only internally converts `UInt128` to
`UInt32`. Note that although it uses some cryptographic primitives, `ARS1x` uses a cryptographically weak key
schedule and is **not** suitable for cryptographic use. The number of rounds must be at least 1 and no more
than 10, and is 7 by default.


## Examples

For detailed usage of each RNG, please refer to the [library docs](@ref Random123).

To use Random123, firstly import the module:
```julia
julia> using RandomNumbers.Random123
```

Take `Philox4x64` for example:
```jldoctest
julia> r = Philox4x();  # will output UInt64 by default, and two seed integers are truly randomly produced.

julia> r = Philox4x((0x12345678abcdef01, 0x10fedcba87654321));  # specify the seed.

julia> r = Philox4x(UInt64, (0x12345678abcdef01, 0x10fedcba87654321));  # specify both the output type and seed.

julia> rand(r, NTuple{4, UInt64})
(0x00d626ee85b7d2ed, 0xa57b4af2b68c655e, 0x82dad737de789de2, 0x8d390e05845e6c4d)

julia> set_counter!(r, 123);  # update the counter manually.

julia> rand(r, UInt64, 4)
4-element Array{UInt64,1}:
 0x56a4eb812faa9cd7
 0xf3d3464a49b23b56
 0xda5a5824aea0b2bb
 0x097a8d117a2bb20a

julia> set_counter!(r, 0);

julia> rand(r, NTuple{4, UInt64})
(0x00d626ee85b7d2ed, 0xa57b4af2b68c655e, 0x82dad737de789de2, 0x8d390e05845e6c4d)
```

[^1]:
    John K. Salmon, Mark A. Moraes, Ron O. Dror, and David E. Shaw, "Parallel Random Numbers: As Easy as
    1, 2, 3," Proceedings of the International Conference for High Performance Computing, Networking, Storage
    and Analysis (SC11), New York, NY: ACM, 2011.
    doi:[10.1145/2063384.2063405](http://dx.doi.org/10.1145/2063384.2063405)
